function [ini_layer_uv, ini_layer_uvb, seg, incon] = compute_init_fuse_seg_flow(this, ini_layer_uv, ini_layer_uvb, ...
    pyramid_images, color_pyramid_images, layer_g, seg)

% refine init from clustering 

% downsample to 1/2 size
ratio = 2;
sz = size(seg{1});
ssz = round(sz/ratio);  % target samller size

%% refine layer_uv and seg{1}
layer_uv = ini_layer_uv; 
layer_mean_affine_uv = fit_affine_layer_motion_g_L1(layer_uv{1}, layer_g{1});

sseg = imresize(seg{1}, ssz, 'nearest');
for i=1:length(layer_uv{1})
    layer_uv_s{i} = imresize(layer_uv{1}{i}, ssz)/ratio;
    layer_mean_affine_uv_s{i} = imresize(layer_mean_affine_uv{i}, ssz)/ratio;
end;
this.images = imresize(pyramid_images{1}, ssz);

if size(color_pyramid_images{1}, 4)>1
    this.labImage = imresize(color_pyramid_images{1}(:,:,:,1), ssz);
else
    this.labImage = imresize(color_pyramid_images{1}(:,:,1), ssz);
end;

layer_ids = [1 2; 1 3; 2 3];

%
% tmp_uv  = layer_uv_s{1};
% ind = repmat(sseg, [1 1 2]);
% for i1 = 2:length(layer_uv_s)
%     tmp_uv(ind ==i1) = layer_uv_s{i1}(ind==i1);
% end;
% 
% tmp_im = [seg2color(sseg) flowToColor(tmp_uv)];
% fn = [this.fileinfo sprintf('_seg_flow_iter_%03d.png', 0)];
% imwrite(tmp_im, fn);
%
% [sseg layer_uv_s] = seg_flow(this, layer_ids, sseg, layer_uv_s, can_uv_s);
for i=1:size(layer_ids,1)
    z_s = zeros(size(sseg));
    z_s(sseg==layer_ids(i,1)) =1;
    z_s(sseg==layer_ids(i,2)) =2;
    can_uv_s = cat(4, layer_uv_s{layer_ids(i,1)},...
                layer_mean_affine_uv_s{layer_ids(i,1)},...
                layer_uv_s{layer_ids(i,2)},...
                layer_mean_affine_uv_s{layer_ids(i,2)} );
    [tuv_s z1_s] = fuse_layer_motion(this, z_s, can_uv_s);            
%     [tuv_s z1_s] = fuse_layer_motiMichael Black wrote:on_BP(this, z_s, can_uv_s);            
    
    % update segmentation    
    sseg(z1_s==1) = layer_ids(i,1);
    sseg(z1_s==2) = layer_ids(i,2);
    
    % update flow field
    layer_uv_s{layer_ids(i,1)} = tuv_s{1};
    layer_uv_s{layer_ids(i,2)} = tuv_s{2};
    % update affine mean flow field
    
end;

seg{1} = imresize(sseg, sz, 'nearest');
for i=1:length(layer_uv{1})
     ini_layer_uv{1}{i} = imresize(layer_uv_s{i}, sz)*ratio;    
end;
%
uvf  = ini_layer_uv{1}{1};
ind = repmat(seg{1}, [1 1 2]);
for i1 = 2:length(ini_layer_uv{1})
    uvf(ind ==i1) = ini_layer_uv{1}{i1}(ind==i1);
end;

%% % refine layer_uv and seg{2}

t = 2;
sseg = imresize(seg{t}, ssz, 'nearest');
%
layer_uvb = ini_layer_uvb;
layer_mean_affine_uv = fit_affine_layer_motion_g_L1(layer_uvb{1}, layer_g{t});
for i=1:length(layer_uvb{1})
    layer_uv_s{i} = imresize(layer_uvb{1}{i}, ssz)/ratio;
    layer_mean_affine_uv_s{i} = imresize(layer_mean_affine_uv{i}, ssz)/ratio;
end;

this.images = imresize(pyramid_images{1}, ssz);
this.images = this.images(:,:,end:-1:1);

if size(color_pyramid_images{1}, 4)>1
    this.labImage = imresize(color_pyramid_images{1}(:,:,:,t), ssz);
else
    this.labImage = imresize(color_pyramid_images{1}(:,:,t), ssz);
end;

for i=1:size(layer_ids,1)
    z_s = zeros(size(sseg));
    z_s(sseg==layer_ids(i,1)) =1;
    z_s(sseg==layer_ids(i,2)) =2;
    can_uv_s = cat(4, layer_uv_s{layer_ids(i,1)},...
                layer_mean_affine_uv_s{layer_ids(i,1)},...
                layer_uv_s{layer_ids(i,2)},...
                layer_mean_affine_uv_s{layer_ids(i,2)} );
    [tuv_s z1_s] = fuse_layer_motion(this, z_s, can_uv_s);            
%     [tuv_s z1_s] = fuse_layer_motiMichael Black wrote:on_BP(this, z_s, can_uv_s);            
    
    % update segmentation    
    sseg(z1_s==1) = layer_ids(i,1);
    sseg(z1_s==2) = layer_ids(i,2);
    
    % update flow field
    layer_uv_s{layer_ids(i,1)} = tuv_s{1};
    layer_uv_s{layer_ids(i,2)} = tuv_s{2};
    % update affine mean flow field
    
end;

seg{2} = imresize(sseg, sz, 'nearest');
for i=1:length(layer_uv{1})
     ini_layer_uvb{1}{i} = imresize(layer_uv_s{i}, sz)*ratio;    
end;
%%
uvb  = ini_layer_uvb{1}{1};
ind = repmat(seg{2}, [1 1 2]);
for i1 = 2:length(ini_layer_uvb{1})
    uvf(ind ==i1) = ini_layer_uvb{1}{i1}(ind==i1);
end;
%%
% Mark inconsistent positions in segmentation over time
for t=1:length(ini_layer_uv)
    tmp = warp_backward_segmentation(seg{t+1}, uvf);
    incon{t} = repmat(tmp~=seg{t}, [1 1 length(ini_layer_uv{1})-1]);
end;

tmp = warp_backward_segmentation(seg{1}, uvb);
t = 2; incon{t} = repmat(tmp~=seg{t}, [1 1 length(ini_layer_uv{1})-1]);

% upsample flow and segmentation to full size