function [ini_layer_uv, ini_layer_uvb, seg, incon, layer_g_o] =...
    compute_init_fuse_seg_flow_gc(this, ini_layer_uv, ini_layer_uvb, ...
    pyramid_images, color_pyramid_images, layer_g, seg)

% refine init from clustering by graph cuts
% alternate optimzation over
%   given flow for each layer, solve hard segmentation
%   given hard segmentation, solve flow field for each layer

% can only process two image pair with forward and backward symmetric flow
% fields

addpath('/home/dqsun/research/program/nips10_flow/test_gc/utils');
addpath('/home/dqsun/research/program/nips10_flow/test_gc/seq_ising');
addpath('/home/dqsun/research/program/nips10_flow/test_gc');

params              = load_parameters;
params.rho_affine   = this.rho_affine;
params.lambdaFlow   = this.lambda;
params.lambdaAff    = this.lambdaAff;
params.lambdaOcc    = this.lambda5;
params.T2_lab       = this.Ti2;  % 7 vs 12
params.sigma_lab    = this.sigma_i; % 20^2 vs 40^2

params.inputDownRatio = this.disDownRatio;

% parse parameters from THIS
[data layer_support flow_sel] = parse_data_seq_si(...
    ini_layer_uv, ini_layer_uvb, pyramid_images, color_pyramid_images,...
    layer_g, seg, params);

params.nCan = size(data.can_uv{1}, 4);
data        = precompute(data, data.can_uv, params);

[H W nLayers T] = size(layer_support); 
nLayers         = nLayers+1;
params.nLayers  = nLayers;
%params.T        = T;
params.T        = length(data.can_uv);

params.startIndex = [1 H*W+1 1];
aff_uv = data.aff_uv;

%%
tmp_flow_sel      = flow_sel;
tmp_layer_support = layer_support;

% % switch layer order affine flow field
% new_order = [2 1 3];
% % new_order = [3 2 1];

% new_order = [3 2 1 4] %4:-1:1 %[1 2 3 4]
% for t=1:params.T
%     data.aff_uv{t} = aff_uv{t}(:,:,:,new_order);
% end;

display_results_si(data.can_uv, tmp_flow_sel, tmp_layer_support);
en = evaluate_overall_energy_si(tmp_layer_support, tmp_flow_sel,...
    data, params, true);
fprintf('energy %3.3e\n', en);
for i=1:params.nGCiters    
    
    % layer segmentation
    tmp_layer_support = segment_layers_gc_seq_ising(tmp_layer_support,...
        tmp_flow_sel, params, data);
%     display_results_si(data.can_uv, tmp_flow_sel, tmp_layer_support);
    
    % simultaneous layer segmentation + flow selection
    [tmp_layer_support tmp_flow_sel]=segment_layers_select_flow_gc_seq_ising(...
        tmp_layer_support, tmp_flow_sel, params, data);
    %display_results_si(data.can_uv, tmp_flow_sel, tmp_layer_support);
    
    % flow selection
    for t=1:params.T;
        for i=1:nLayers
            tmp_flow_sel{t}(:,:,i) = select_flow_gc_si(tmp_layer_support,...
                 t, i, params, data, tmp_flow_sel{t}(:,:,i));
        end;
    end;
    display_results_si(data.can_uv, tmp_flow_sel, tmp_layer_support);
   
    % refine layer support for each layers    
    
    % re-estimate affine mean
    data=estimate_affine_mean(data,tmp_flow_sel,tmp_layer_support,params);
    
    en = evaluate_overall_energy_si(tmp_layer_support, tmp_flow_sel,...
            data, params, true);
    fprintf('energy %3.3e\n', en);
end

% remove layers that have less than 0.1 percent visible pixels

% [tmp_layer_support tmp_flow_sel] = post_process_si(data,
% tmp_layer_support tmp_flow_sel);

layer_seg = support2seg(tmp_layer_support);

%% upsample flow and segmentation to full size
sz = size(this.images);
sz = sz(1:2);
ratio = params.inputDownRatio;

for t=1:params.T
    seg{t} = imresize(layer_seg(:,:,t), sz, 'nearest');
end;

for t=1:params.T-1
    for i=1:params.nLayers
        uv = composite_final_flow_seg(data.can_uv{t},...
            tmp_flow_sel{t}(:,:,i));
        ini_layer_uv{t}{i}  = imresize(uv, sz)*ratio;
        
        % TODO: only works for T=2 now
        uv = composite_final_flow_seg(data.can_uv{t+1},...
            tmp_flow_sel{t+1}(:,:,i));
        ini_layer_uvb{t}{i} = imresize(uv, sz)*ratio;
    end;
end;

uvf = composite_final_flow_seg(ini_layer_uv{1},  seg{1});
uvb = composite_final_flow_seg(ini_layer_uvb{1}, seg{2});
%%
% mark inconsistent positions in segmentation over time
for t=1:params.T-1
    tmp = warp_backward_segmentation(seg{t+1}, uvf);
    incon{t} = repmat(tmp~=seg{t}, [1 1 length(ini_layer_uv{1})-1]);
end;

tmp = warp_backward_segmentation(seg{1}, uvb);
t = 2; incon{t} = repmat(tmp~=seg{t}, [1 1 length(ini_layer_uv{1})-1]);

% convert discrete layer support to continuous layer support
for t=1:params.T
    tmp = imresize(tmp_layer_support(:,:,:,t), sz, 'nearest');
    layer_g_o{t} = (2*tmp-1)*this.visG;
end;
