function [ini_layer_uv_o, ini_layer_uvb_o, seg_o, incon_o, layer_g_o] =...
    compute_init_fuse_seg_flow_gc_asym(this, ini_layer_uv, ini_layer_uvb, ...
    pyramid_images, color_pyramid_images, layer_g, seg)
%%
% refine init from clustering by graph cuts, alternate optimzation over
%   given flow for each layer, solve hard segmentation
%   given hard segmentation, solve flow field for each layer

% TODO: addpath in the beginning
fdir        = this.extParams.discCodeDir; 
addpath(fdir);
addpath([fdir 'utils']);
addpath([fdir 'seq_ising']);
addpath(genpath([fdir 'seq_ising/asym']));

% parse parameters from THIS, precompute
[data solution params] = parse_data_seq_si_asym(ini_layer_uv, ini_layer_uvb,...
     pyramid_images, color_pyramid_images, layer_g, seg, this);

data        = precompute_asym(data, params);


outputDir   = [this.extParams.discDir];

params.fdir = this.extParams.discDir; 
if ~exist(params.fdir, 'file')
    mkdir(params.fdir);
end;

if this.nLayers == 2;    
    % 2-layer case:    
    [data solution params ] = determine_depth_ordering_disc_init(...
        data, solution, params, this, outputDir);
else
    % tic
    %%%%%%%%%% determine depth ordering
    [data solution params ] = determine_depth_ordering_disc_init(...
        data, solution, params, this, outputDir);
    
    %%%%%%%%%%%%%% swap depth ordering
    [data solution params ] = load_or_swap_depth_order_pairiwse_asym(...
        data, solution, params, this, outputDir);
    
    %%%%%%%%%%%%%%% final refinement
    [data solution params ] = load_or_refine_disc_init(...
        data, solution, params, this, outputDir);
end;
%%%%%%%%%%% convert to continuous format
[ini_layer_uv_o, ini_layer_uvb_o, seg_o, incon_o, layer_g_o] = ...
convert_to_cont_data(data, solution, params, this);

