function [ini_layer_uv, ini_layer_uvb, seg, incon] = compute_init_fuse_seg_flow_gc_sep(this, ini_layer_uv, ini_layer_uvb, ...
    pyramid_images, color_pyramid_images, layer_g, seg)

% refine init from clustering by graph cuts
% alternate optimzation over
%   given flow for each layer, solve hard segmentation
%   given hard segmentation, solve flow field for each layer

% downsample to 1/2 size
ratio = 4; % 2
sz = size(seg{1});
ssz = round(sz/ratio);  % target samller size

%% refine layer_uv and seg{1}
layer_uv = ini_layer_uv; 
% layer_mean_affine_uv = fit_affine_layer_motion_g_L1(layer_uv{1}, layer_g{1});
layer_mean_affine_uv = fit_affine_layer_motion_g(layer_uv{1}, layer_g{1});
layer_uvb = ini_layer_uvb; 
% layer_mean_affine_uvb = fit_affine_layer_motion_g_L1(layer_uvb{1}, layer_g{2});
layer_mean_affine_uvb = fit_affine_layer_motion_g(layer_uvb{1}, layer_g{2});

sseg{1} = imresize(seg{1}, ssz, 'nearest');
sseg{2} = imresize(seg{2}, ssz, 'nearest');

for i=1:length(layer_uv{1})
    layer_uv_s{i} = imresize(layer_uv{1}{i}, ssz)/ratio;
    layer_mean_affine_uv_s{i} = imresize(layer_mean_affine_uv{i}, ssz)/ratio;
    layer_uvb_s{i} = imresize(layer_uvb{1}{i}, ssz)/ratio;
    layer_mean_affine_uvb_s{i} = imresize(layer_mean_affine_uvb{i}, ssz)/ratio;
end;

images = imresize(pyramid_images{1}, ssz);
this.images = images;

if size(color_pyramid_images{1}, 4)>1
    this.labImage = {imresize(color_pyramid_images{1}(:,:,:,1), ssz), imresize(color_pyramid_images{1}(:,:,:,2), ssz)};
else
    this.labImage = {imresize(color_pyramid_images{1}(:,:,1), ssz), imresize(color_pyramid_images{1}(:,:,2), ssz)};
end;
%

can_uv = [];can_uv2 = [];
for i=1:length(layer_uv_s)
    can_uv = cat(4, can_uv, layer_uv_s{i});
    can_uv = cat(4, can_uv, layer_mean_affine_uv_s{i});
    
    can_uv2 = cat(4, can_uv2, layer_uvb_s{i});
    can_uv2 = cat(4, can_uv2, layer_mean_affine_uvb_s{i});
end;    

luv = [];luv2 = [];
for i=1:length(layer_uv_s)
    luv = cat(4, luv, layer_uv_s{i});
    luv2 = cat(4, luv2, layer_uvb_s{i});
end;    

oz = cat(3, sseg{1}, sseg{2});
lambdaA = 5e2; lambdaB = 1e0; lambdaD = 9;
figure; imagesc(oz(:,:,1));
%%
uv1 = composite_final_flow_seg(luv, oz(:,:,1));  %figure; imshow(flowToColor(uv1));
all = [seg2color(oz(:,:,1)) flowToColor(uv1)];
% imwrite(all, 'flow_seg_step0.png');

tic

%% TODO change to member of class
lambdaZ = 7.5e2;
niters = 1;

for iter = 1:niters
    % Solve segmentation
    this.images = images;
    [ouv oz] = fuse_seg_motion(this, oz, {luv,luv2}, lambdaZ);    
    % solve flow field for each layer

%     uv1 = composite_final_flow_seg(luv, oz(:,:,1)); figure; imshow(flowToColor(uv1));
%     uv2 = composite_final_flow_seg(luv2, oz(:,:,2)); figure; imshow(flowToColor(uv2));
%     figure; imagesc(oz(:,:,1));
%     all = [seg2color(oz(:,:,1)) flowToColor(uv1)];
%     imwrite(all, 'flow_seg_step1.png');
%     imshow(all);
    figure; 
    uvf = composite_final_flow_seg(luv, oz(:,:,1));     
    uvb = composite_final_flow_seg(luv2, oz(:,:,2));         
    all = [seg2color(oz(:,:,1)) seg2color(oz(:,:,2));...
           flowToColor(uvf) flowToColor(uvb)];
    imshow(all);
    
    for l=1:size(luv, 4)
        this.images = images;
        luv(:,:,:,l)  = fuse_motion_given_seg(this, l, oz(:,:,1), oz(:,:,2), can_uv(:,:,:,2*l-1:2*l));        
%         luv(:,:,:,l)  = fuse_motion_given_seg(this, l, oz(:,:,1), oz(:,:,2), can_uv, lambdaL);        
        this.images = images(:,:,2:-1:1);
        luv2(:,:,:,l) = fuse_motion_given_seg(this, l, oz(:,:,2), oz(:,:,1), can_uv2(:,:,:,2*l-1:2*l));
%         luv2(:,:,:,l) = fuse_motion_given_seg(this, l, oz(:,:,2), oz(:,:,1), can_uv2, lambdaL);
    end;
    
    figure; 
    uvf = composite_final_flow_seg(luv, oz(:,:,1));     
    uvb = composite_final_flow_seg(luv2, oz(:,:,2));         
    all = [seg2color(oz(:,:,1)) seg2color(oz(:,:,2));...
           flowToColor(uvf) flowToColor(uvb)];
    
    %imwrite(all, 'flow_seg_step2.png');
    imshow(all);
%     uv2 = composite_final_flow_seg(luv2, oz(:,:,2)); figure; imshow(flowToColor(uv2));
%     figure; imagesc(oz(:,:,1));
%     figure; imagesc(oz(:,:,2));
end;

toc

%%
seg{1} = imresize(oz(:,:,1), sz, 'nearest');
seg{2} = imresize(oz(:,:,2), sz, 'nearest');

for i=1:length(layer_uv{1})
     ini_layer_uv{1}{i}  = imresize(luv(:,:,:,i), sz)*ratio;    
     ini_layer_uvb{1}{i} = imresize(luv2(:,:,:,i), sz)*ratio;    
end;
uvf = composite_final_flow_seg(ini_layer_uv{1},  seg{1});
uvb = composite_final_flow_seg(ini_layer_uvb{1}, seg{2});

%%
% Mark inconsistent positions in segmentation over time
for t=1:length(ini_layer_uv)
    tmp = warp_backward_segmentation(seg{t+1}, uvf);
    incon{t} = repmat(tmp~=seg{t}, [1 1 length(ini_layer_uv{1})-1]);
end;

tmp = warp_backward_segmentation(seg{1}, uvb);
t = 2; incon{t} = repmat(tmp~=seg{t}, [1 1 length(ini_layer_uv{1})-1]);

% upsample flow and segmentation to full size