function uv = estimate_flow_gradient_ascent(this, uv, niters, tau, tu, tv)
% Estimate the flow field by performing gradient ascent on the log
% posterior from the initial value UV  

for i = 1:niters
    duv = evaluate_log_posterior_grad(this, uv);
    duv = duv/max(abs(duv(:)));
    uv  = uv + duv*tau;
    if mod(i, niters/10) == 0
        fprintf('log-posterior\t%3.3e\n', evaluate_log_posterior(this, uv));
        if nargin == 6
            [aae stdae aepe] = flowAngErr(tu, tv, uv(:,:,1), uv(:,:,2), 0);
            fprintf('AAE %3.3f STD %3.3f average end point error %3.3f \n\n', aae, stdae, aepe);
        end;
    end;
end;
