function [layer_uv z] = fuse_layer_motion_BP(this, z, can_uv)

% choose between two candidate layers, which a pixel belongs to (z), and
% for every pixel in each layer, choose its motion vector among a candidate
% set of motion vectors (l1/l2)

% layer_uv{1}(i,j, :) = can_uv{l1(i,j)}(i,j, :)

% note that these two layers may not cover the entire image plane

addpath('/u/dqsun/research/program/iccv2011_flow/fuse_seg_flow/MDMRF');

lambdaZ = 5.5e1;  % 45
lambdaL = 5e1;    % 5
lambdaZ = 0e1;  % 45 % for test

[H W]= size(z);
ind = find(z>0); % initial value, 1: layer1, 2: layer2, 0: other layers
nvalid  = numel(ind);
z0 = z(ind);
l1 = ones(H, W);
l2 = ones(H, W)*3;
%[z0 l1 l2] is the initial value of the solution
  
nZ = 2;              % only two layers
%nC = length(can_uv); % 1: current flow of layer1, 2: affien flow of layer1, 3 current flow of % laery 2, 4 affine flow of layer 2, to add: 5c+nl, sift, block matching...)
nC = size(can_uv, 4); 

% Precompute the data term for each candidate flow field
aIt2 = zeros([H W nC]);
for i = 1:nC   
    It          = partial_deriv(this.images, can_uv(:,:,:,i), this.interpolation_method, this.deriv_filter);               
    aIt2(:,:,i) = reshape(evaluate(this.rho_data, It(:)), size(It));
    % TODO: occlusion handling
end;

% Compute color weights
dif2 = zeros(size(this.labImage, 1)-1, size(this.labImage, 2));
for j=1:size(this.labImage, 3)
    dif2 = dif2 + (this.labImage(1:end-1,:,j) -this.labImage(2:end,:,j) ).^2;
end;
dif2 = dif2/size(this.labImage, 3)*3;
dif2(dif2>this.Ti2) = this.Ti2;
weightV = exp(-dif2/2/this.sigma_i^2);
weightV = [weightV; zeros(1, size(weightV,2))];

dif2 = zeros(size(this.labImage, 1), size(this.labImage, 2)-1);
for j=1:size(this.labImage, 3)
    dif2 = dif2 + (this.labImage(:,1:end-1,j) -this.labImage(:,2:end,j) ).^2;
end;
dif2 = dif2/size(this.labImage, 3);
dif2(dif2>this.Ti2) = this.Ti2;
weightH = exp(-dif2/2/this.sigma_i^2);
weightH = [weightH zeros(size(weightH,1), 1)];

% Collapse initial z, l1, l2 into a single variable

valid_z = z >0;

zll = (l2-1) + (l1-1)*nC;
zll(valid_z) = zll(valid_z) + (z(valid_z)-1)*nC^2;

% [zll(1, 2) zll(3,5)]

% data0=0;
% tmp = aIt2(:,:,1); tmp(~valid_z) = 0; tmp(z==2)=0; data0 = data0+sum(tmp(:));
% tmp = aIt2(:,:,3); tmp(~valid_z) = 0; tmp(z==1)=0;data0 = data0+sum(tmp(:));
% data0


% zll_new = fuse_layer_flow_mex(zll, aIt2, can_uv, weightH, weightV, valid_z, 2*nC^2, nC, lambdaZ, lambdaL, this.rho_spatial_u{1}.params);
zll_new = fuse_layer_flow_mex(zll, aIt2, can_uv, weightH, weightV, valid_z, 2*nC^2, nC, lambdaZ, lambdaL);

% %%
% %initial data term value
% % 
% data0=0;
% tmp = aIt2(:,:,1); tmp(~valid_z) = 0; tmp(z==2)=0; data0 = data0+sum(tmp(:));
% tmp = aIt2(:,:,3); tmp(~valid_z) = 0; tmp(z==1)=0;data0 = data0+sum(tmp(:));
% data0
% % 
% % inital spatail term
% %% L
% s0 = 0;
% tmp = abs(can_uv(:,1:end-1,1:2)-can_uv(:,2:end,1:2));
% s0 = s0+sum(tmp(:));
% 
% tmp = abs(can_uv(1:end-1,:,1:2)-can_uv(2:end,:,1:2));
% s0 = s0+sum(tmp(:));
% 
% tmp = abs(can_uv(:,1:end-1,5:6)-can_uv(:,2:end,5:6));
% s0 = s0+sum(tmp(:));
% 
% tmp = abs(can_uv(1:end-1,:,5:6)-can_uv(2:end,:,5:6));
% s0 = s0+sum(tmp(:));
% 
% s0 = s0*lambdaL
% 
% %% Z
% sz0 = 0;
% 
% valid_zh = valid_z(:,1:end-1) & valid_z(:,2:end);
% valid_zv = valid_z(1:end-1,:) & valid_z(2:end, :);
% z0 = z;
% zh = z0(:,1:end-1) ~= z0(:,2:end);  zh(~valid_zh) = 0;
% zv = z0(1:end-1, :) ~= z0(2:end, :);zv(~valid_zv) = 0;
% 
% sz0 = sum(sum(weightH(:, 1:end-1).*double(zh))) + sum(sum(weightV(1:end-1, :).*double(zv)));
% sz0 = lambdaZ*sz0;
% sz0+s0
%%
% nC = 4;
% z = 1; l1 = 2; l2 = 3;
% zll_new = (z-1)*nC^2+(l1-1)*nC+l2-1;

z  = ceil( (zll_new+1) /nC^2);
l1 = mod( floor(zll_new/nC), nC)+1;
l2 = mod(zll_new, nC)+1;
z(~valid_z) = 0;
% figure; imagesc(z);
% [z l1 l2 z_new l1_new l2_new]

%%


tind   = [1:H*W]' + (l1(:)-1)*H*W*2;
layer_uv{1}(:,:,1) = reshape(can_uv(tind), [H W]);
layer_uv{1}(:,:,2) = reshape(can_uv(tind+H*W), [H W]);
tind   = [1:H*W]' + (l2(:)-1)*H*W*2;
layer_uv{2}(:,:,1) = reshape(can_uv(tind), [H W]);
layer_uv{2}(:,:,2) = reshape(can_uv(tind+H*W), [H W]);

% figure; imagesc(reshape(l1, [H W]));
% figure; imagesc(reshape(l2, [H W]));
% Arrange solution into normal format