function fuse_layer_motion_test(this)

if (~isdeployed)
    addpath(genpath('/u/dqsun/research/program/outlier/utils/OBPQ/'));
end
%%
% return;

nC = 4
sz = 100*[1 1];
can_uv = ones([sz 2 nC])*5;
can_uv(:,:,:,1) = can_uv(:,:,:,1) + randn(size(can_uv(:,:,:,1)))*0.2;
can_uv(:,:,:,3:4) = -can_uv(:,:,:,3:4);
can_uv(:,:,:,3) = can_uv(:,:,:,3) + randn(size(can_uv(:,:,:,3)))*0.2;

im1 = rand(sz)*255;
im2 = rand(sz)*255;
im2(1:45, 1:45) = im1(6:50, 6:50);
im2(55:100, 55:100) = im1(50:95, 50:95);

% im2(1:4, 1:4) = im1(2:5, 2:5);
% im2(6:10, 6:10) = im1(5:9, 5:9);


this.images = cat(3, im1, im2);
%this.images = rand([sz 2])*255;
this.labImage = ones(sz)*255;
this.labImage(sz(1)/4:end-sz(1)/4,sz(2)/4:end-sz(2)/4) = 125;

%z0 = round(rand(sz))+1;

z0 = ones(sz);
% z0(5:10, 1:4) = 0;
% z0(50:100, 1:40) = 0;
%%
[layer_uv1 z1] = fuse_layer_motion(this, z0, can_uv);
% figure; imshow(flowToColor(layer_uv1{1}));
% figure; imshow(flowToColor(layer_uv1{2}));
% figure; imagesc(z1)

%%
[layer_uv z2] = fuse_layer_motion_BP(this, z0, can_uv);
% figure; imshow(flowToColor(layer_uv{1}));
% figure; imshow(flowToColor(layer_uv{2}));
% figure; imagesc(z2)

%%
% [layer_uv2 z2] = fuse_layer_motion(this, z, can_uv);
% figure; imshow(flowToColor(layer_uv2{1}));
% figure; imshow(flowToColor(layer_uv2{2}));
% figure; imagesc(z2)


%%
%%

% layer_ids = [1 3];
% 
% z=zeros(size(seg{1}));
% z(seg{1}==layer_ids(1)) = 1;
% z(seg{1}==layer_ids(2)) = 2;
% 
% can_uv = cat(4, layer_uv{1}{layer_ids(1)},...
%                 layer_mean_affine_uv{layer_ids(1)},...
%                 layer_uv{1}{layer_ids(2)},...
%                 layer_mean_affine_uv{layer_ids(2)} );
% [tuv z1] = fuse_layer_motion(this, z, can_uv);            
% 
% figure; imshow(flowToColor(tuv{1}));
% figure; imshow(flowToColor(tuv{2}));
% figure; imshow(z1, [])
% z = threhold_g(layer_g{1});
%%
layer_uv = ini_layer_uv; 
% layer_g  = ini_layer_g;
layer_mean_affine_uv = fit_affine_layer_motion_g_L1(layer_uv{1}, layer_g{1});
this.images = pyramid_images{1};
if size(color_pyramid_images{1}, 4)>1
    this.labImage = color_pyramid_images{1}(:,:,:,1);
else
    this.labImage = color_pyramid_images{1}(:,:,1);
end;

%%

sz = size(seg{1});
ratio = 2;
% Reduce size for fast test
%ssz = [80 120];
ssz = round(sz/ratio);
seg_init = imresize(seg{1}, ssz, 'nearest');

for i=1:length(layer_uv{1})
    layer_uv_s{i} = imresize(layer_uv{1}{i}, ssz)/ratio;
    layer_mean_affine_uv_s{i} = imresize(layer_mean_affine_uv{i}, ssz)/ratio;
end;

this.images = imresize(pyramid_images{1}, ssz);

if size(color_pyramid_images{1}, 4)>1
    this.labImage = imresize(color_pyramid_images{1}(:,:,:,1), ssz);
else
    this.labImage = imresize(color_pyramid_images{1}(:,:,1), ssz);
end;
%%
figure; imshow([this.images(:,:,1) this.images(:,:,2)], []);
%%

lambdaZ = 3e0;
lambdaL = 5e0;
lambdaZ = 5.5e1*3.1/1.8*2; 
lambdaL = 5e0/2*3.1/1.8;

layer_ids = [1 3; 1 2; 2 3]; % swapping order
layer_ids = [1 2; 1 3; 2 3];
% layer_ids = [1 2; 1 3; 2 3; 1 3; 2 3; 1 2]; % swapping order

% layer_ids = [ 1 3];

sseg = seg_init;
%
tmp_uv  = layer_uv_s{1};
ind = repmat(sseg, [1 1 2]);
for i1 = 2:length(layer_uv_s)
    tmp_uv(ind ==i1) = layer_uv_s{i1}(ind==i1);
end;

tmp_im = [seg2color(sseg) flowToColor(tmp_uv)];
fn = [this.fileinfo sprintf('_seg_flow_iter_%03d.png', 0)];
imwrite(tmp_im, fn);
figure; imshow(tmp_im);
%
for i=1:size(layer_ids,1)
    z_s = zeros(size(sseg));
    z_s(sseg==layer_ids(i,1)) =1;
    z_s(sseg==layer_ids(i,2)) =2;
    can_uv_s = cat(4, layer_uv_s{layer_ids(i,1)},...
                layer_mean_affine_uv_s{layer_ids(i,1)},...
                layer_uv_s{layer_ids(i,2)},...
                layer_mean_affine_uv_s{layer_ids(i,2)} );
    tic
    [tuv_s z1_s] = fuse_layer_motion(this, z_s, can_uv_s, lambdaZ, lambdaL);            
    toc
%     [tuv_s z1_s] = fuse_layer_motiMichael Black wrote:on_BP(this, z_s, can_uv_s);            
    
    % update segmentation    
    sseg(z1_s==1) = layer_ids(i,1);
    sseg(z1_s==2) = layer_ids(i,2);
    
    % update flow field
    layer_uv_s{layer_ids(i,1)} = tuv_s{1};
    layer_uv_s{layer_ids(i,2)} = tuv_s{2};
    % update affine mean flow field
    
    %figure; imagesc(sseg);
    %
    tmp_uv  = layer_uv_s{1};
    ind = repmat(sseg, [1 1 2]);
    for i1 = 2:length(layer_uv_s)
        tmp_uv(ind ==i1) = layer_uv_s{i1}(ind==i1);
    end;
    %figure; imshow(flowToColor(tmp_uv));
    
%     figure; 
%     subplot(1, 2, 1); imagesc(sseg); axis image off; 
%     subplot(1, 2, 2); imagesc(flowToColor(tmp_uv));axis image off
%     title(sprintf('iter %d', i));
%
    %tmp_im = [seg2color(sseg) nan(size(sseg,1), 3,3) flowToColor(tmp_uv)];
    tmp_im = [seg2color(sseg) flowToColor(tmp_uv)];
    fn = [this.fileinfo sprintf('down%d_seg_flow_iter_%03d.png', ratio, i)];
    
    figure; imshow(tmp_im);
    imwrite(tmp_im, fn);
%
end;

%     figure; imshow(tmp_im);
%     figure; imshow(flowToColor(tuv_s{2}))
%%
% [tuv_s z1_s] = fuse_layer_motion(this, z_s, can_uv_s);            
% figure; imshow([z_s nan(size(z_s,1), 3) z1_s], [])
% figure; imshow(flowToColor(tuv_s{1}));
% figure; imshow(flowToColor(tuv_s{2}));




% layer_ids = [1 3];
% z=zeros(size(seg{1}));
% z(seg{1}==layer_ids(1)) = 1;
% z(seg{1}==layer_ids(2)) = 2;
% z_s = imresize(z, ssz, 'nearest');
% 
% can_uv = cat(4, layer_uv{1}{layer_ids(1)},...
%                 layer_mean_affine_uv{layer_ids(1)},...
%                 layer_uv{1}{layer_ids(2)},...
%                 layer_mean_affine_uv{layer_ids(2)} );
% for i=1:size(can_uv,4)
%     can_uv_s(:,:,:,i) = imresize(can_uv(:,:,:,i), ssz) /4;
% end;
% 
