function puv = generate_flow_proposals2(this, nP, uv)

% GENERATE_FLOW_PROPOSALS generate NP different local solutions for the flow
% estimation method

% Use constant flow / random flow as initial value and then run gradient descent on the
% energy function 

%%% parameter for gradient ascent
niters = 200;
tau    = 3e-2;

%%% determine the initial values (constant flow) by clustering the H&S
%%% result

if nargin < 3
    hs          = hs_optical_flow;
    hs.images   = this.images;
    uv          = compute_flow(hs);
end;

tmp1    = uv(:,:,1);
tmp2    = uv(:,:,2);
UV      = [tmp1(:), tmp2(:)];

if nargin == 1
    [id C]  = kmeans(UV, 32);
else
    [id C]  = kmeans(UV, round(nP));
end;


H       = size(this.images,1);
W       = size(this.images,2);
ini    = ones(H, W);


% Perform gradient ascent on log posterior from constant flow
for ip = 1:size(C, 1);

    uv  = cat(3, C(ip, 1)*ini, C(ip,2)*ini);    
    
%     for i = 1:niters
%         duv = evaluate_log_posterior_grad(this, uv);
%         duv = duv/max(abs(duv(:)));
%         uv  = uv + duv*tau;
% %         if mod(i, niters/10) == 0
% %             fprintf('\nlog-posterior\t%3.2e\n', evaluate_log_posterior(this, uv));
% %         end;
%     end;

    fprintf('log-posterior\t%3.2e\n\n', evaluate_log_posterior(this, uv));

    puv{ip} = uv;    
end;

% % proposals from L-K
% ip = nP+1;
% %%% proposals computed using L&K
% windowSize  = 1:4;
% levels      = 1:4;
% 
% for i = 1:length(windowSize)
%     for j = 1:length(levels)
%         [u,v] = HierarchicalLK(this.images(:,:,1), this.images(:,:,2), levels(j), windowSize(i), 3, 0);
%         %     puv{ip} = cat(3, u,v);
%         u = imresize(u,[size(this.images,1) size(this.images,2)]);
%         v = imresize(v,[size(this.images,1) size(this.images,2)]);        
%         
%         uv = cat(3, u,v);
%         puv{ip} = uv;
%         ip = ip+1;
%         fprintf('log-posterior\t%3.2e\n\n', evaluate_log_posterior(this, uv));
%     end;
% end;
s = load('venusproposals.mat');
puv = [puv s.lk];