function puv = generate_flow_proposals(this, nP)

% GENERATE_FLOW_PROPOSALS generate NP different local solutions for the flow
% estimation method

%%% proposals computed using H&S
hs          = hs_optical_flow;
hs.images   = this.images;
lambdas     = [20 200 500 2000]/3600;
levels      = 1:4;

ip = 1;
for i = 1:length(lambdas)
    for j = 1:length(levels)
        hs.pyramid_levels = levels(j);
        hs.lambda = lambdas(i);
        
        uv = compute_flow(hs);
        %     puv{ip} = compute_flow(hs);
        fn = sprintf('result/proposal/proposal%03d.mat', ip);
        save(fn, 'uv');
        ip = ip + 1;
        evaluate_log_posterior(this, uv)
    end;
end;

% ip = 1;
%%% proposals computed using L&K
% windowSize = 1:4;
% 
% for i = 1:length(windowSize)
%     for j = 1:length(levels)
%         [u,v] = HierarchicalLK(this.images(:,:,1), this.images(:,:,2), levels(j), windowSize(i), 3, 0);
%         %     puv{ip} = cat(3, u,v);
%         u = imresize(u,[size(this.images,1) size(this.images,2)]);
%         v = imresize(v,[size(this.images,1) size(this.images,2)]);        
%         
%         uv = cat(3, u,v);
%         fn = sprintf('result/proposal/proposal%03d.mat', ip);
%         save(fn, 'uv');
%         ip = ip+1;
%         evaluate_log_posterior(this, uv)
%     end;
% end;
% 
% if nargout > 0
%     puv = [];
% end;
% % cluster to generate constant proposals
% NC = 32;
% UV = [];
% for i = 1:32;
%     fn = sprintf('result/proposal/proposal%03d.mat', i);
%     s  = load(fn);
%     puv{i} = s.uv;
% end;
% 
% [IDX C ] = kmeans(UV, NC);
% cuv = ones(size(s.uv));
% for i = 1:size(C, 1);
%     uv = cat(3, cuv(:,:,1)*C(1,i), cuv(:,:,2)*C(2,i));
%     puv{ip}  =  uv;
% %     fn = sprintf('result/proposal/proposal%03d.mat', ip);
% %     save(fn, 'uv');
%     ip = ip+1;
% end;
    
    
    

% % %%Use different lambda values and the quadratic energy function
% % % lambda_qs = linspace(-5, 5, nP);
% % % lambda_qs = this.lambda_q * 2.^lambda_qs;
% % % 
% % % % Generate different proposals
% % % this.gnc_iters = 1;
% % % for i = 1:nP;
% % %     % Use quadratic form
% % %     this.alpha              = 1;    
% % %     this.pyramid_levels     = 4;
% % %     this.pyramid_spacing    = 2;
% % %     this.lambda_q           = lambda_qs(i);
% % %     puv{i}                  = compute_flow(this);
% % %     
% % %     % thresholding too large estimates;
% % %     T = 10*mean(abs(puv{i}(:)));
% % %     puv{i}(puv{i} > T)      = T;
% % %     puv{i}(puv{i} < -T)     = -T;
% % % end;
% % % 
% % % % Use the proposals above as initial values
% % % for i = 1:nP;
% % %     % Use desired (non convex) form
% % %     this.alpha              = 0.5;
% % %     this.lambda_q           = lambda_qs(i);    
% % %     this.pyramid_levels     = 2;
% % %     this.pyramid_spacing    = 1.25;
% % %     puv{i+nP}               = compute_flow(this, puv{i});
% % % end;
% % % 
% % % for i = 1:nP;
% % %     % Use desired (non convex) form
% % %     this.alpha              = 0;
% % %     this.pyramid_levels     = 2;
% % %     this.pyramid_spacing    = 1.25;
% % %     puv{i+2*nP}               = compute_flow(this, puv{i+nP});
% % % end;

% this.gnc_iters = 1;
% MAX_FLOW = 10;
% for i = 1:nP;
%     % Use desired (non convex) form
%     this.alpha              = 0;
%     this.pyramid_levels     = 1;
%     this.pyramid_spacing    = 1.25;
%     ini = MAX_FLOW * (2*i-nP)/nP*ones(size(this.images,1), size(this.images,2), 2);
%     puv{i}               = compute_flow(this, ini);
% end;