function layer_uv = affine_interpolate_invisible(layer_uv, layerLabels)

% fit affine motion to the visible pixels of each layer, interpolate the
% motion of the invisible using affine motion model; motion of visible
% pixels remain unchanged

nL = length(layer_uv);

luv = fit_affine_layer_motion(layer_uv, layerLabels);


[tmp ind ] = max(layerLabels, [], 3);
ind = repmat(ind, [1 1 2]);

 for i = 1:nL
     layer_uv{i}(ind~=i) = luv{i}(ind~=i);     
 end;


% for i = 1:nL
%     
%     uv = layer_uv{i};
%     u = uv(:,:,1); u = u(:);    
%     v = uv(:,:,2); v = v(:);
%     
%     % fit affine motion to visible pixels
%     tmp_u = u(ind==i);
%     tmp_v = v(ind==i);
%     tmp_xy1 = xy1(ind==i, :);
%     A(:,1) = L2_fit(tmp_u, tmp_xy1);
%     A(:,2) = L2_fit(tmp_v, tmp_xy1);
%     
%     % interpolate invisble pixels by affine motion model
%     u2 = X*A(1,1)+Y*A(2,1)+A(3,1);
%     v2 = X*A(1,2)+Y*A(2,2)+A(3,2);
% 
%     % only modify invisible pixels
%     u(ind~=i) = u2(ind~=i);
%     v(ind~=i) = v2(ind~=i);
%     
%     u = reshape(u, sz);
%     v = reshape(v, sz);
%     
%     layer_uv{i} = cat(3, u, v);
% 
% end;

