function layer_uv = affine_interpolate_invisible_g(layer_uv, layer_g, mode, rho, dataset_name)
% fit affine motion to the visible pixels of each layer, interpolate the
% motion of the invisible using affine motion model; motion of visible
% pixels remain unchanged

nL = length(layer_uv);

if nargin <3
    mode = 'affine';
end;

switch mode
    case 'affine'
        luv = fit_affine_layer_motion_g(layer_uv, layer_g, rho, dataset_name);
    case 'projective'
        luv = fit_projective_layer_motion_g(layer_uv, layer_g);
    case 'affineL1'        
        luv = fit_affine_layer_motion_g_L1(layer_uv, layer_g);
    otherwise        
        %disp('unknown motion model, use affine instaed');
        luv = fit_affine_layer_motion_g(layer_uv, layer_g, rho, dataset_name);
end;

ind = threshold_g(layer_g);
ind = repmat(ind, [1 1 2]);

 for i = 1:nL
     
     % code added by laura sevilla to avoid boundaries 
     mask = (ind~=i);
     if (i==2) && strcmp(dataset_name, 'kitti')
        se = strel('disk', 5);
        mask = imdilate(mask, se);
     end
     layer_uv{i}(mask) = luv{i}(mask);     
 end;


% for i = 1:nL
%     
%     uv = layer_uv{i};
%     u = uv(:,:,1); u = u(:);    
%     v = uv(:,:,2); v = v(:);
%     
%     % fit affine motion to visible pixels
%     tmp_u = u(ind==i);
%     tmp_v = v(ind==i);
%     tmp_xy1 = xy1(ind==i, :);
%     A(:,1) = L2_fit(tmp_u, tmp_xy1);
%     A(:,2) = L2_fit(tmp_v, tmp_xy1);
%     
%     % interpolate invisble pixels by affine motion model
%     u2 = X*A(1,1)+Y*A(2,1)+A(3,1);
%     v2 = X*A(1,2)+Y*A(2,2)+A(3,2);
% 
%     % only modify invisible pixels
%     u(ind~=i) = u2(ind~=i);
%     v(ind~=i) = v2(ind~=i);
%     
%     u = reshape(u, sz);
%     v = reshape(v, sz);
%     
%     layer_uv{i} = cat(3, u, v);
% 
% end;

