function layer_uv = affine_possion_interpolate_invisible_g(layer_uv, layer_g)
% Use possion equation to interpolate motion of invisble pixels for each
% layer based on the visible pixels

% near possion
% far affine

ind = threshold_g(layer_g);
 for i = 1:length(layer_uv)
     layer_uv{i}(:,:,1) = possion_inpaint(layer_uv{i}(:,:,1), ind ==i);
     layer_uv{i}(:,:,2) = possion_inpaint(layer_uv{i}(:,:,2), ind ==i);
 end;
 
 layer_uv2 = affine_interpolate_invisible_g(layer_uv, layer_g);
 %%
%  f = fspecial('gaussian',[10 10], 3);
f = fspecial('gaussian',[5 5], 2);
 for i = 1:length(layer_uv)
     
     mask = ind ==i;     
     mask = imdilate(mask, ones(10,10));    % so as to have transition from 1 to 1 
     
     mask = imfilter(mask, f);
     
     mask = repmat(mask, [1 1 2]);
     
     layer_uv{i} = mask.*layer_uv{i} + (1-mask).*layer_uv2{i};
 end;
 
 disp('');