function all = composite_illustration_image(uv, nL, layer_uv, layer_g)
%%
% composte the illustration image
sz  = size(layer_g(:,:,1));
all = zeros(sz(1)*nL, sz(2)*3, 3);

% if mod(nL, 2) == 0
%     all = zeros(sz(1)*nL, sz(2)*3, 3);
% else
%     all = zeros(sz(1)*(nL+1), sz(2)*3, 3);
% end;

% obtain max flow magnitude, same scaling for all flow fields
rad = sqrt(uv(:,:,1).^2 + uv(:,:,2).^2);
maxFlow = max(rad(:));

if ~isempty(layer_uv)
    for i = 1:nL;
        rad = sqrt(layer_uv{i}(:,:,1).^2 + layer_uv{i}(:,:,2).^2);
        maxFlow = max(maxFlow, max(rad(:)));
    end;
end;

if ~isempty(layer_uv)
    for i = 1:nL;
        all((i-1)*sz(1)+1:sz(1)*i, 1:sz(2), :) = flowToColor(layer_uv{i}, maxFlow);
    end;
end;

tmp_layer_g = scale_image(layer_g, 0, 255);
for i = 1:nL-1; 
    all((i-1)*sz(1)+1:sz(1)*i, 1+sz(2):2*sz(2), :) =.... 
            repmat(tmp_layer_g(:,:,i), [1 1 3]); 
    %repmat(scale_image(layer_g(:,:,i), 0, 255), [1 1 3]); 

end;

% scale together
% for i = 1:nL; tmp((i-1)*sz(1)+1:sz(1)*i, 1:sz(2), :, :) = layer_uv{i}; end;
% all(:, 1:sz(2), :) = flowToColor(tmp);
% clear tmp;
% for i = 1:nL-1; tmp((i-1)*sz(1)+1:sz(1)*i, 1:sz(2), :) = layer_g(:,:,i); end;
% tmp = scale_image(tmp, 0, 255);
% all(1:sz(1)*(nL-1), 1+sz(2):2*sz(2), :) = repmat(tmp, [1 1 3]); 

if ~isempty(uv)
    all((nL-1)*sz(1)+1:sz(1)*nL, 1+sz(2):2*sz(2), :) = flowToColor(uv, maxFlow); 
end;

% Threshold g to obtain hard segmentation
ind = ones(sz(1), sz(2)) * nL;

for i = 1:nL-1; 
    tmp = layer_g(:,:,i)>=0;
    for j = 1:i-1;
        tmp = tmp & layer_g(:,:,j)<0;
    end;    
    tmp = double(tmp);
    % visible in front layers
    tmp(ind < i) = 0.5; 
    
    all((i-1)*sz(1)+1:sz(1)*i, 1+sz(2)*2:sz(2)*3, :) =...
    repmat(tmp, [1 1 3])*255;
    
    ind(tmp ==1) = i;    
end;


all((nL-1)*sz(1)+1:sz(1)*nL, 1+sz(2)*2:sz(2)*3, :) = seg2color(ind);

% f(:,:,1) = cos(ind*2*pi/nL);
% f(:,:,2) = sin(ind*2*pi/nL);
% all((nL-1)*sz(1)+1:sz(1)*nL, 1+sz(2)*2:sz(2)*3, :) = flowToColor(f);

% if isempty(layer_uv)
%     all = all(:,sz(2)+1:end, :);
% end;


if nL >= 6
    if mod(nL,2) ==0
        all = [all(1:end/2,:,:) all(1+end/2:end,:,:)];
    else
        
        n = round(nL/2);
        
        all = [all(1:n*sz(1),:,:)...
            [all(1+n*sz(1):end,:,:); zeros([sz(1) size(all,2) 3])] ];
    end;
end;

