function [seg ] = compute_ini_seg_kmeans_color(uvf, uvb, nL, nCandidate, ims)
%%
% cluster the flow field of first frame into nL groups by kmeans clustering
%  in the color space

segs    = cell(1,nCandidate);
score   = ones(1,nCandidate)*1e32;
seg     = cell(1,length(uvf)+1);
t_sel   = round(length(uvf)/2);   % selected center frame

if size(ims,4) == 1
    im  = ims(:,:,t_sel);
    im  = reshape(im, [], 1);
else
    im  = ims(:,:,:,t_sel);
    im  = reshape(im, [], 3);
end
H = size(ims,1);
W = size(ims, 2);

for i = 1:nCandidate
    [segs{i} tmp{i} sumd] = kmeans(im, nL);    
    score(i) = sum(sumd);
    %figure; imagesc(reshape(segs{i}, H, W));
end;

[tmp ind] = min(score);
seg{t_sel} = reshape(segs{ind}, H, W);


for t = t_sel+1:length(uvf)+1
    seg{t} = warp_backward_segmentation(seg{t-1}, uvb{t-1});    
end;

for t = t_sel-1:-1:1
    seg{t} = warp_backward_segmentation(seg{t+1}, uvf{t});    
end;