function [seg layer_uv] = compute_ini_seg_merge(uvf, uvb, nL, nCandidate, sz)
% Cluster the flow field of first frame into nL groups by affine motion
% Then use backward flow to obtain the segmentaion for the following frames

% cluster more affine motion fields, merge according to affine coefficients

N = max(8, nL*2);  

for i = 1:nCandidate
    [A{i} score(i) segs{i}] =robust_fit_affine_motion(uvf{1}, N);   
    
    % for quick test
%     if min(score) == score(i)
%         figure; imagesc(segs{i}); title(num2str(score(i)));
%     end;
    layer_uv = affine2layer(A{i}, [size(uvf{1},1) size(uvf{1},2)]);
    
end;
[tmp ind] = min(score);

tmp = [A{ind}(:,:,1); A{ind}(:,:,2)];
ttt = kmeans(tmp', nL);
segt = segs{ind};
for i=1:N; 
    segt(segs{ind}==i) = ttt(i); 
end;

seg{1} = segt;

for t = 2:length(uvf)+1
    seg{t} = warp_backward_segmentation(seg{t-1}, uvb{t-1});
end;
%%
