function psi = construct_libDAI_structure_L_Z_temporal(aIt2, cliqueT, indZ10, indZ20, indL0, isLogDomain, z1_index, lambdaD)
%%

% Note that the indZ10 is always about the first binary field z1, while
% indZ20 z2, whether z1 or z2 is in the first column of cliqueT

% TODO: For valid pixels in z1 that have no corresponding valid pixels in z2
% a pairwise term bewteen it and the corresponding pixels in L
% CURRENT: Pre-set these data terms to be zero so that the compatability
% function is always 0 (1) for that factor

% tic
% isLogDomain = false;
% H = 100; W = 100;
% H = 400;W = 400;
% aIt2 = rand([H W 6]);

% indZ10 = H*W; % first variable is ind*0 in the whole variables
% indZ20 = 0;  
% indL0  = 2*H*W+1;

% can_uv = rand([H W 2 6]);
% cliqueT = round(rand(H*W*3,2)*H*W);
% cliqueT(:,2) = cliqueT(:,2)+H*W;
% cliqueT(cliqueT==0) = 1;

H  = size(aIt2,1);
W  = size(aIt2,2);

nZ = 2;
nL = size(aIt2,3);
nTC = size(cliqueT,1);

%potential_tables = zeros(nTC, nZ*nZ*nL);

potential_tables = zeros(nZ, nZ, nL, nTC);
z1=z1_index; z2 = z1;
for l=1:nL
    ind = cliqueT(:,1) + (l-1)*H*W;    
    if (cliqueT(1,1)>H*W)
        % second z field is in the first column
        ind = ind - H*W;
    end;
    %potential_tables(:, z1+(z2-1)*nZ+(l-1)*nZ*nZ) = aIt2(ind);    
    potential_tables(z1, z2, l, :) = aIt2(ind);    
end;
% changing from being observed to occluded/out of boundary

potential_tables(z1, z2, l, :) = aIt2(ind);    


% convert energy function to log compatability function
% TO DO/TRY: add a scale lambda
if isLogDomain
    potential_tables = -potential_tables;
else
    potential_tables = exp(-potential_tables);
end;

psi = cell(1,nTC);

indL = cliqueT(:,1)-1+indL0;

if cliqueT(1,1) > H*W
    % first column is in the second field Z, swithc z1 z2 to cardinality order
    cliqueT = cliqueT(:,2:-1:1);
    
    indL = indL - indZ20; % need to minus the shift
end;

% cliqueT(:,1) = cliqueT(:,1)-1+indZ10;
% cliqueT(:,2) = cliqueT(:,2)-1+indZ20;

cliqueT(:,1) = cliqueT(:,1)-1;
cliqueT(:,2) = cliqueT(:,2)-1;


for i=1:nTC;
    psi{i}.Member = [cliqueT(i,:) indL(i)];
    psi{i}.P      = potential_tables(:,:,:,i);
end;

% toc
