function psi = construct_libDAI_structure_Z2_L_Z1_temporal(aIt2, cliqueT, indZ10, indZ20, indL0, isLogDomain, z2_index, lambdaD, oob, onInd)
%%

% cliqueT first column: Z2 (larger index), second Z1

% TODO: For valid pixels in z1 that have no corresponding valid pixels in z2
% a pairwise term bewteen it and the corresponding pixels in L
% CURRENT: Pre-set these data terms to be zero so that the compatability
% function is always 0 (1) for that factor

% tic
% isLogDomain = false;
% H = 100; W = 100;
% H = 400;W = 400;
% aIt2 = rand([H W 6]);

% indZ10 = H*W; % first variable is ind*0 in the whole variables
% indZ20 = 0;  
% indL0  = 2*H*W+1;

% can_uv = rand([H W 2 6]);
% cliqueT = round(rand(H*W*3,2)*H*W);
% cliqueT(:,2) = cliqueT(:,2)+H*W;
% cliqueT(cliqueT==0) = 1;

H  = size(aIt2,1);
W  = size(aIt2,2);

nZ = 2;
nL = size(aIt2,3);
nTC = size(cliqueT,1);

% potential_tables = zeros(nZ, nZ, nL, nTC);
potential_tables = ones(nZ, nZ, nL, nTC)*lambdaD;   % test

z2=z2_index; z1 = z2;

ind = cliqueT(:,1) + (onInd-1)*H*W;
ind = ind - indZ20;    % subtract the shift

ind2= z1+(z2-1)*nZ + (onInd-1)*nZ^2 + (0:nTC-1)'*nZ^2*nL;
potential_tables(ind2) = aIt2(ind);

%Change from being observed to occluded/out of boundary
z2=z2_index; z1 = 3-z2;
ind2= z1+(z2-1)*nZ + (onInd-1)*nZ^2 + [0:nTC-1]'*nZ^2*nL;
potential_tables(ind2) = lambdaD;    

%%%%%%%% wrong code
% for l=1:nL
%     ind = cliqueT(:,1) + (l-1)*H*W;    
%     ind = ind - indZ20;    % subtract the shift        
%     potential_tables(z1, z2, l, :) = aIt2(ind);    
% end;
%Change from being observed to occluded/out of boundary
% potential_tables(3-z2_index, z2_index, :, :) = lambdaD;    

% convert energy function to log compatability function
% TO DO/TRY: add a scale lambda
if isLogDomain
    potential_tables = -potential_tables;
else
    potential_tables = exp(-potential_tables);
end;

psi = cell(1,nTC);

indL = cliqueT(:,1)-1+indL0;
indL = indL - indZ20; % need to minus the shift

% shift Z1 and Z2 so that first column has smaller index
cliqueT = cliqueT(:,2:-1:1);

% By default, Z1: 0 to H*W-1; Z2: H*W:2*H*W-1
cliqueT(:,1) = cliqueT(:,1)-1;
cliqueT(:,2) = cliqueT(:,2)-1;


for i=1:nTC;
    psi{i}.Member = [cliqueT(i,:) indL(i)];
    psi{i}.P      = potential_tables(:,:,:,i);
end;


