% function psi = construct_libDAI_structure_Z_spatial(lambdaZ, vert, hor, ind0, validZ, wv1, wh1, isLogDomain)
%%
% tic;
isLogDomain = true;
H = 10;W = 10;
ind0 = 100; % first variable is ind0 in the whole variables
lambdaZ = 1;

% cliques
vert = im2col((reshape(1:H*W,H,W)),[2 1])';%vertical
hor  = im2col((reshape(1:H*W,H,W)),[1 2])';%horizontal
nV = size(vert,1);
nH = size(hor,1);

% wv1  = ones(nV,1); wh1  = ones(nH,1);
wv1  = ones(H*W,1); wh1  = ones(H*W,1);

validZ = rand(H,W)>0.5;


nZ = 2; 

%%
% valid cliques for z
indV = validZ(1:end-1,:) & validZ(2:end,:);
% indV = tmp;
valid_vert_z = vert(indV, :); % correct?

indH = validZ(:,1:end-1)& validZ(:,2:end);
% indH = tmp;
valid_hor_z = hor(indH, :);

nV = size(valid_vert_z,1);
nH = size(valid_hor_z,1);
%%
potential_tables = zeros(nZ, nZ, nV+nH);

IsingTables = [0 1; 1 0]; % penalty/energy function
%%
% wv1 and wh1 have been padded to have size H * W
%
for i=1:nZ;
    for j=1:nZ
        potential_tables(i, j, :) = [wv1(valid_vert_z(:,1)); wh1(valid_hor_z(:,1))]*IsingTables(i,j);
    end;
end;
%%
if isLogDomain
    potential_tables = -lambdaZ*potential_tables;
else
    potential_tables = exp(-lambdaZ*potential_tables);
end;
%
psi = cell(1, nV+nH);
valid_vert_z = valid_vert_z-1+ind0;
valid_hor_z  = valid_hor_z-1+ind0;
%
for i=1:nV
    psi{i}.Member = valid_vert_z(i,:);
    psi{i}.P = potential_tables(:,:,i);
end;

for i=1:nH
    psi{i+nV}.Member = valid_hor_z(i,:);
    psi{i+nV}.P = potential_tables(:,:,i+nV);
end;    

% toc

