function psi = construct_libDAI_structure_Z_spatial_all(lambdaZ, vert, hor, ind0, wv1, wh1, isLogDomain)
%%

% construct the compatability function for the color-weighted Ising model
% for binary field Z

% tic;
% isLogDomain = false;
% H = 10;W = 10;
% ind0 = 0; % first variable is ind0 in the whole variables
% lambdaZ = 1;
% 
% % cliques
% vert = im2col((reshape(1:H*W,H,W)),[2 1])';%vertical
% hor  = im2col((reshape(1:H*W,H,W)),[1 2])';%horizontal
% 
% % wv1  = ones(nV,1); wh1  = ones(nH,1);
% wv1  = ones(H*W,1); wh1  = ones(H*W,1);

nV = size(vert,1);
nH = size(hor,1);
nZ = 2; 
potential_tables = zeros(nZ, nZ, nV+nH);

IsingTables = [0 1; 1 0]; % penalty/energy function

% alp = 0.05;
% IsingTables = [alp 1-alp; 1-alp alp];

for i=1:nZ;
    for j=1:nZ
        potential_tables(i, j, :) = [wv1(vert(:,1)); wh1(hor(:,1))]*IsingTables(i,j);
    end;
end;
%
if isLogDomain
    potential_tables = -lambdaZ*potential_tables;
else
    potential_tables = exp(-lambdaZ*potential_tables);
end;
%
psi = cell(1, nV+nH);
vert = vert-1+ind0;
hor  = hor-1+ind0;
%
for i=1:nV
    psi{i}.Member = vert(i,:);
    psi{i}.P = potential_tables(:,:,i);
end;

for i=1:nH
    psi{i+nV}.Member = hor(i,:);
    psi{i+nV}.P = potential_tables(:,:,i+nV);
end;    

% toc

