function uvo = fit_affine_layer_motion_one_layer(uv, ind)
% Fit affine motion to the visible pixels specified by IND of flow field UV

sz = size(uv); sz = sz(1:2);

if nargin <2
    ind = ones(sz);
end;

nData = prod(sz);
[X Y] = meshgrid(1:sz(2), 1:sz(1));
x   = X(:); 
y   = Y(:);
xy1 = [x y ones(nData, 1)];

u = uv(:,:,1); u = u(:);
v = uv(:,:,2); v = v(:);

% fit affine motion to visible pixels
tmp_u = u(ind==1);
tmp_v = v(ind==1);
tmp_xy1 = xy1(ind==1, :);
A(:,1) = L2_fit(tmp_u, tmp_xy1);
A(:,2) = L2_fit(tmp_v, tmp_xy1);

% interpolate invisble pixels by affine motion model
u = X*A(1,1)+Y*A(2,1)+A(3,1);
v = X*A(1,2)+Y*A(2,2)+A(3,2);

u = reshape(u, sz);
v = reshape(v, sz);

uvo = cat(3, u, v);

