function fu = fit_affine_motion(u, ind)
% Fit affine motion field to the valid pixels specified by IND

sz = size(ind);
nData = prod(sz);
[X Y] = meshgrid(1:sz(2), 1:sz(1));
x = X(:); y = Y(:);
xy1 = [x y ones(nData, 1)];

u = u(:);
% fit affine motion to visible pixels
tmp_u = u(ind==1);
tmp_xy1 = xy1(ind==1, :);
A = (tmp_xy1'*tmp_xy1)\(tmp_xy1'*tmp_u);

% compute affine motion field
fu = X*A(1,1)+Y*A(2,1)+A(3,1);
fu = reshape(fu, sz);
