function out = pairwise_potential_tableZT(vals, aIt2,  H, W, nCan, lambdaD)

% Compute the temporal pairwise term for layer segmentation

visible = vals(3,:)== vals(4,:);

ind1 = vals(1,:);

if (ind1(1,1)>H*W)
    % from t+1 to t data term
    ind1 = ind1-H*W;        
end;

ind1 = ind1 + (vals(3,:)-1)*H*W;

out = aIt2(ind1).*visible;

% disable temporal data terms that are not activated
%%
nBatch = size(vals,2)/nCan;

disabled = zeros(size(out));

for iCan=1:nCan;
    tmp = vals(3, (iCan-1)*nBatch+1:iCan*nBatch );
    tmp = tmp~=iCan;    
    disabled((iCan-1)*nBatch+1:iCan*nBatch) = tmp;
end;    

out(disabled==1) = -lambdaD;    % due to the subtraction
