function out = pairwise_potential_tableZT_order(vals, aIt2,  H, W, OOB, nCan, lambdaD)

% Compute the temporal pairwise term for layer segmentation

% a pixel changes from back layers to front layers/out of boundary 0 (equivalently lambdaD) penalty

% a pixel changes from front layers to back layers: large penalty

cf  = vals(3,:) > vals(4,:); % correct flip
wf  = vals(3,:) < vals(4,:); % wrong flip from front layer to back layer

ind1 = vals(1,:);

if (ind1(1,1)>H*W)
    % from t+1 to t data term
    ind1 = ind1-H*W;        
end;

ind1 = ind1 + (vals(3,:)-1)*H*W;

out = aIt2(ind1);

out(cf) = 0;    % back layer occluded by front
out(wf) = 0;    % penalize more for front layers occluded by back ones

% reduce BCE at segmentation inconsistency
% ratio = 5; 
% out(cf) = out(cf)/ratio;    % back layer occluded by front
% out(wf) = out(wf)/ratio;    % penalize more for front layers occluded by back ones


% Penalize segmentation inconsistency
% lambdaSeg = 1;
% out(cf) = out(cf) + lambdaSeg;
% out(wf) = out(wf) + lambdaSeg;

% % set moving out of boundary to 0 penalty
oob = OOB(ind1); 
out(oob) = 0;

%%
% disable temporal data terms that are not activated


nBatch = size(vals,2)/nCan;

disabled = zeros(size(out));

for iCan=1:nCan;
    tmp = vals(3, (iCan-1)*nBatch+1:iCan*nBatch );
    tmp = tmp~=iCan;    
    disabled((iCan-1)*nBatch+1:iCan*nBatch) = tmp;
end;    

out(disabled==1) = -lambdaD;    % due to the subtraction