function layer_uv = pp_layer_flow(layer_uv, layerLabels, rgbim, images)

% convert from RGB to LAB
im = RGB2Lab(rgbim);          % to Lab space
for j = 1:size(im, 3);
    im(:,:,j) = scale_image(im(:,:,j), 0, 255);
end;

% composite flow field
uv = composite_final_flow(layer_uv, layerLabels);

% compute occlusion state,
occ = detect_occlusion(uv, images);
uv = denoise_color_weighted_medfilt2(uv, im, occ, 7, [5 5], 7);

% Update corresponding layer motion
[tmp ind ] = max(layerLabels, [], 3);
ind = repmat(ind, [1 1 2]);

for i1 = 1:length(layer_uv)
    layer_uv{i1}(ind==i1) = uv(ind ==i1);
end;