function ind = threshold_g(layer_g)

% Compute hard segmentation by thresholding g
sz = size(layer_g);
nL = size(layer_g, 3)+1;

ind = ones(sz(1), sz(2)) * nL;  % hard segmentation
left = ones(sz(1), sz(2));      % record of remaining pixels

for i = 1:nL-1;
    % Determine visible pixels in the current layer
    tmp = layer_g(:,:,i)>=0 & left==1;
    % Mark them from the remaining pixels
    left(tmp==1) = 0;
    % Record the hard segmentation
    ind(tmp==1) = i;    
end;

ind = uint8(ind);