function puv = process_flow_proposals_GD(this, puv)

% Perform gradient descent on negative log posterior on the input proposals

%%% parameter for gradient ascent
niters = 200;
tau    = 3e-2;

% Perform gradient ascent on log posterior from constant flow
for ip = 1:length(puv)

    uv  = puv{ip};
    
    for i = 1:niters
        duv = evaluate_log_posterior_grad(this, uv);
        duv = duv/max(abs(duv(:)));
        uv  = uv + duv*tau;
    end;

    fprintf('log-posterior\t%3.2e\n\n', evaluate_log_posterior(this, uv));

    puv{ip} = uv;    
end;
