function [uvf, uvb, support, illustration, illustrationb] = estimate_support_flow(...
    params, uvf, uvb, images)
%%

model = load_fc_2_layers_parameters;

% parse parameters
% model.lambda   = params.lambda;
% model.lambda_q = params.lambda;
% model.fileinfo = [];%params.outputDir;
model.extParams= params;

% new code for semantic segmentation
model.class_mask = params.class_mask; 
model.isstuff = params.isstuff;
model.prior = params.prior;
model.images = imcells2array(images);

if length(uvf) ==1 % always uses symmetric for 2 frames
    model.is_symmetric = true;
end;

init = {uvf, uvb};
if length(init{1}) ==1
    % always uses symmetric for 2 frames
    model.is_symmetric = true;
end;

model.lambda4 = model.lambda4s(model.pyramid_levels, 1);

[pyramid_images, color_pyramid_images, grayImages] = build_image_pyramid(model);
model.extParams.grayImages = grayImages;

% load semantic mask 
seg0 = model.class_mask;
for i=1:length(seg0)
    seg0{i} = double(seg0{i});
end
    
% convert initial clustering to support and flow field
[ini_layer_uv0, ini_layer_uvb0, layer_g0, incon0]=...
    convert_init_seg_to_support(model, init, seg0);

% mean-field based inference
[layer_uvf, layer_uvb, ~, ~, support] =...
    compute_init_mf(model, ini_layer_uv0, ini_layer_uvb0, ...
    pyramid_images, color_pyramid_images, layer_g0, init);

[uvf, illustration, uvb, illustrationb] = composite_layered_final_output(...
    layer_uvf, layer_uvb, support, model);
