function params = load_parameters
%%
% parameter setting

% below will be modified


params.cont_refine       = true; 
params.cont_refine_iters = 3;



% according to continuous model
params.T2_lab           = 25^2;  %40
params.lambdaOcc        = 8;
params.sigma_lab        = 12;
params.lambdaFlow       = 3;
params.inputDownRatio   = 2;



% according to data
params.T                = 2;  

% according to input parameters
params.lambdaSeg        = 7.5e1;
params.lambdaIncon      = 3; % temporal inconsisntecy between support functions
params.lambdaAff        = 10;


params.lambdaForbid     = 8; % temporarily


params.alt_niters       = 3;


params.nIgnore          = 100; % layers with less visible pixels than this number ignored

params.deriv_filter         = [1 -8 0 8 -1]/12;
params.interpolation_method = 'bi-cubic';

a       = 0.45;
sig     = 1e-3;
method  = 'generalized_charbonnier'; %'lorentzian'


params.rho_data     = robust_function(method, sig, a);
params.rho_color    = robust_function('quadratic', 1);   % weight for support function/segmentation
params.rho_affine   = robust_function(method, sig, a);
params.rho_spatial  = robust_function(method, sig, a);


params.t            = 4;
params.seqName      = 'bird_apple'; 





params.nCan         = params.nLayers+1;
params.iBest        = 1;   % selects the one with ith lowest fitting error
params.nLayers      = 3;
params.homeDir      = '/data/vision/dqsun/program/iccv11_flow/';
params.nGCiters     = 2;
params.nClusterRun  = 15;


params.nSwapIters   = 12;     % max # iters for swapping depth order
params.nSwapT       = 5;     % regions with neighoring pixels larger than this are adjacent
params.nMaxSwapPairs= 10;  % maximum # of pairs to compare

params.display      = false;
params.fdir         = '/data/vision/dqsun/program/iccv11_flow/result/output/disc_temp/';

params.downOption   = []; %'hires_0.5'; % subsample on high-res grid 1/2 size
params.spaCliqueType= '4NN';

params.maxMoveIters = 3; % maximum number of QPBO iteration per individual move