function uv = composite_final_flow_g(layer_uv, layer_g)


sz = size(layer_uv{1});
nL = length(layer_uv);

% Obtain hard segmentation by thresholding g

ind = ones(sz(1), sz(2)) * nL;  % hard segmentation

left = ones(sz(1), sz(2));      % record of remaining pixels

for i = 1:nL-1;
    % Determine visible pixels in the current layer
    tmp = layer_g(:,:,i)>=0 & left==1;
    % Mark them from the remaining pixels
    left(tmp==1) = 0;
    % Record the hard segmentation
    ind(tmp==1) = i;    
end;

ind = repmat(ind, [1 1 2]);
uv  = layer_uv{1};
for i1 = 2:length(layer_uv)
    uv(ind ==i1) = layer_uv{i1}(ind==i1);
end;


