function  N = computeOcclusionPixelNumber(seg, ini_layer_uv, nL)
%%
% compute number of occluded pixels (segmentation changes over time)
% between each layer 

if nargin < 3
    nL = max(seg(:));
end;


N = zeros(nL,nL);

for t=1:size(seg,3)-1

    uv = composite_final_flow_seg(ini_layer_uv{t}, seg(:,:,t));
    s1 = seg(:,:,t);
    ws = warp_backward(uv, seg(:,:,t+1), 'nearest');
    
    ws(isnan(ws)) = s1(isnan(ws));

    mask = s1~=ws;
% figure; imshow(mask);
    ss1  = s1(mask);
    ss2  = ws(mask);
    
    for i=1:nL
        for j=1:nL;
            N(i,j) = N(i,j) + sum(ss1==i & ss2==j);
        end;
    end;
    
    N = N+N';
end;