function pairs = compute_pairs_to_swap(data, solution,  params)
%%
layer_seg   = support2seg(solution.layer_support);
NN          = computeNeighborsPixelNumber(layer_seg(:,:,1));
pairs       = [];
for i=1:size(NN,1)
    for j=1:i
        if NN(i,j)> params.nSwapT
            pairs = [pairs; j i];
        end
    end;
end;

if size(pairs,1) > params.nMaxSwapPairs
    % select pairs that have the largest occlusion regions
    Nocc = computeOcclusionPixelNumber(layer_seg, data.layer_uv);
    
    % add occlusion region areas using the backward flow field
   
    Nt = prctile(Nocc(:), round( (1- params.nMaxSwapPairs*2/numel(Nocc) ) *100));    
    pairs = [];    
    for i=1:size(Nocc,1)
        for j=1:i
            if Nocc(i,j)> Nt
                pairs = [pairs; j i];
            end
        end;
    end;
    
end;