function out_img = display_results_si_asym(data, solution, t, isForward)
%%



[H W nP T] = size(solution.layer_support);
nLayers = nP+1;

% composite flow field for each layer
tmp_layer_seg = support2seg(solution.layer_support);
% for t0=1:T-1;
%     for iL=1:nLayers
%         layer_uv{t0}(:,:,:,iL) = composite_final_flow_seg(can_uv{t0},...
%             solution.flow_sel{t0}(:,:,iL));
%     end;
% end;

if nargin < 3
    t = 1; 
end;

if t >T
    t = T;
end;

if nargin < 4
    isForward = true;
end;

if mod(nLayers,2) ==0
    %nRow = max(4, round(nLayers/2)*2+2);
    nRow = nLayers+2;
else
    nRow = nLayers+1;
end;
nCol = 2;

img = zeros(H*nRow, W*nCol, 3);

%%% segmentation
r=1; c=2;
if isForward
    img((r-1)*H+1:r*H, (c-1)*W+1:c*W,:) = seg2color(tmp_layer_seg(:,:,t));
else
    img((r-1)*H+1:r*H, (c-1)*W+1:c*W,:) = seg2color(tmp_layer_seg(:,:,t+1));
end;

%%% composite flow field
if isForward
    if t < T
        r=1; c=1;
        uv  = composite_final_flow_seg(data.layer_uv{t}, tmp_layer_seg(:,:,t));
        img((r-1)*H+1:r*H, (c-1)*W+1:c*W,:) = flowToColor(uv);
    end;
else    
    if t < T
        r=1; c=1;
        uv  = composite_final_flow_seg(data.layer_uvb{t}, tmp_layer_seg(:,:,t));
        img((r-1)*H+1:r*H, (c-1)*W+1:c*W,:) = flowToColor(uv);
    end;
end;

%%% support for each layer
c=2; 
for iL=1:nLayers-1
    r=iL+1;
    if isForward
        img((r-1)*H+1:r*H, (c-1)*W+1:c*W,:) =...
            repmat(solution.layer_support(:,:,iL, t), [1 1 3])*255;
    else
        img((r-1)*H+1:r*H, (c-1)*W+1:c*W,:) =...
            repmat(solution.layer_support(:,:,iL, t+1), [1 1 3])*255;
    end;
end;

if t < T
    %%%% flow field of each layer
    c=1;
    for iL=1:nLayers
        r=iL+1;
        if isForward
            img((r-1)*H+1:r*H, (c-1)*W+1:c*W,:) =...
                flowToColor(data.layer_uv{t}(:,:,:,iL));
        else
            img((r-1)*H+1:r*H, (c-1)*W+1:c*W,:) =...
                flowToColor(data.layer_uvb{t}(:,:,:,iL));
        end;
    end;
    
%     % flow selection for each layer
%     c=3;
%     for iL=1:nLayers
%         r=iL+1;
%         img((r-1)*H+1:r*H, (c-1)*W+1:c*W,:) =...
%             repmat(solution.flow_sel{t}(:,:,iL), [1 1 3])*10;
%     end;
end;

if nLayers >=3
    img = [img(1:end/2, :, :) img(end/2+1:end, :, :)];
end;

if nargout > 0
    out_img = img;
else
    %imshow(uint8(img));
    % figure;
    % full screen figure
    scrsz = get(0,'ScreenSize');
    figure('Position',[1 scrsz(4) scrsz(3) scrsz(4)]);
    imagesc(uint8(img));
    axis off;
end;



% % final flow field, layer segmentation, occlusion
% subplot(nRow,nCol,1); imshow(tmp_layer_seg(:,:,t), []);  
% %imagesc(tmp_layer_seg(:,:,t)); 
% axis off; 
% %title('segmentation at time t');
% 
% uv  = composite_final_flow_seg(layer_uv{t}, tmp_layer_seg(:,:,t));
% subplot(nRow,nCol,2); imshow(flowToColor(uv)); 
% % title('flow field at time t');
% 
% % flow field of each layer
% for iL=1:nLayers
%     
%     subplot(nRow,nCol,iL+nCol); 
%     imshow(flowToColor(layer_uv{t}(:,:,:,iL)));
%     %title(['flow field layer ' num2str(iL) ]);
% end;
% 
% % support for each layer
% for iL=1:nLayers-1
%     
%     subplot(nRow,nCol,iL+2*nCol); 
%     imshow(solution.layer_support(:,:,iL, t), []);
%     %title(['support function layer ' num2str(iL) ]);
% end;
% 
% % flow selection for each layer
% for iL=1:nLayers    
%     subplot(nRow,nCol,iL+3*nCol); 
%     imshow(solution.flow_sel{t}(:,:,iL), []);
%     %title(['flow selection layer ' num2str(iL) ]);
% end;




%%% occlusion reasoning
% for t=1:T
%     uv{t} = composite_final_flow_seg(layer_uv, tmp_layer_seg(:,:,t));
% end;
% 
% warpedSeg = warp_backward_segmentation(tmp_layer_seg(:,:,2), uv{1});
% 
% % figure;imagesc(tmp_layer_seg(:,:,1)); 
% % figure; imagesc(tmp_layer_seg(:,:,1)~=warpedSeg);
% occ = tmp_layer_seg(:,:,1)~=warpedSeg;
% seg1 = tmp_layer_seg(:,:,1);
% 
% for i=1:nLayers
%     for j=1:nLayers
%         
%         if i==j
%             continue;
%         end;
%         
%         tmp = seg1==i & warpedSeg ==j;
%         fprintf('%d %d %d\n', i,j,sum(tmp(:)));
%     end;
% end;



% t = 1;
% figure; 
% subplot(2,2,1); imagesc(tmp_layer_seg(:,:,t)); axis off;
% title('segmentation at time t');
% uv  = composite_final_flow_seg(layer_uv{t}, tmp_layer_seg(:,:,t));
% subplot(2,2,3); imshow(flowToColor(uv));
% title('flow field at time t');
% t=2;
% subplot(2,2,2); imagesc(tmp_layer_seg(:,:,t)); axis off;
% title('segmentation at time t+1');
% uv  = composite_final_flow_seg(layer_uv{t}, tmp_layer_seg(:,:,t));
% subplot(2,2,4); imshow(flowToColor(uv));
% title('flow field at time t+1');


% figure; 
% t=1;
% uv  = layer_uv{t}(:,:,:,1);
% subplot(2,2,1); imshow(flowToColor(uv));
% uv  = layer_uv{t}(:,:,:,2);
% subplot(2,2,2); imshow(flowToColor(uv));
% uv  = layer_uv{t}(:,:,:,3);
% subplot(2,2,3); imshow(flowToColor(uv));
% subplot(2,2,4);
% t=1; uv  = composite_final_flow_seg(layer_uv{t}, layer_seg(:,:,t));
% imshow(flowToColor(uv));