function en = evaluate_fusion_flow_energy(uv, aff_uv, images, params, vis, sup)

%%

% data term
[matchCost, OOB, tempNeighbors] = compute_data_match_cost_oob(uv,...
    images, params);
% occlusion
tmp  = vis(:,:,2);
visw = tmp(tempNeighbors);
%     occInd = vis(:,:,1) ~= visw;
matchCost(visw==0) = params.lambdaOcc;
% out of boundaries
matchCost(OOB==1) = params.lambdaOcc;
enData = sum(matchCost(:));

if exist('sup', 'var')
    % support inconsistency
    supw = sup(:,:,2);
    supw = supw(tempNeighbors);
    tmp = sup(:,:,1)~=supw;
    enData = enData + params.lambdaIncon*sum(tmp(:));
end

% affine deviation
uvDif = uv-aff_uv;
enAff  = params.lambdaAff * sum(evaluate(params.rho_affine, uvDif(:)));
%%


% spatial smoothness
if strcmp(params.flowPrior, 'mrfOnDev')
    uv  = uv-aff_uv;    
end

uvx = uv(:,1:end-1,:) - uv(:,2:end,:);
uvy = uv(1:end-1,:,:) - uv(2:end,:,:);
enFlow = params.lambdaFlow*sum(evaluate(params.rho_spatial, uvx(:)));
enFlow = enFlow + params.lambdaFlow*sum(evaluate(params.rho_spatial, uvy(:)));

en = enData + enAff + enFlow;
fprintf('%3.6e\t\t%3.6e\t%3.6e\t%3.6e\n', en, enData, enAff, enFlow);