function data = precompute_asym(data, params)
%%
% compute data term cost, temporal neighbors, out-of-boundary mask

T   = length(data.layer_uv)+1;

for t=1:T-1        
    % forward flow field
    [data.matchCost{t} data.OOB{t}  data.tempNeighbors{t}] = ...
        compute_data_match_cost_oob(data.layer_uv{t},...
        data.images(:,:,t:t+1), params);    
    
    if params.is_symmetric    
        % backward flow field
        [data.matchCost_b{t} data.OOB_b{t}  data.tempNeighbors_b{t}] = ...
            compute_data_match_cost_oob(data.layer_uvb{t},...
            data.images(:,:,t+1:-1:t), params);
    end;    
    
end;

