function [data solution params] = swap_depth_order_pairiwse_asym(data, solution, params)
%%
% layer_seg   = support2seg(solution.layer_support);
% NN          = computeNeighborsPixelNumber(layer_seg(:,:,1));
% pairs       = [];
% for i=1:size(NN,1)
%     for j=1:i
%         if NN(i,j)> params.nSwapT
%             pairs = [pairs; j i];
%         end
%     end;
% end;
% 
% if size(pairs,1) > params.nMaxSwapPairs
%     % select pairs that have the largest occlusion regions
%     Nocc = computeOcclusionPixelNumber(layer_seg, data.layer_uv);
%    
%     Nt = prctile(Nocc(:), round( (1- params.nMaxSwapPairs*2/numel(Nocc) ) *100));    
%     pairs = [];    
%     for i=1:size(Nocc,1)
%         for j=1:i
%             if Nocc(i,j)> Nt
%                 pairs = [pairs; j i];
%             end
%         end;
%     end;
%     
% end;

iChange = round(rand()*1e4);

iterMatch = 1; %0

for iter =1:params.nSwapIters   
    % permuate neighboring pairs
    
    if mod(iter, 2)==1
        success = true;
    end;
    
    % (re)compute paris to swap for the current iteration
    pairs = compute_pairs_to_swap(data, solution, params);
    
    prevEn  = evaluate_overall_energy_si_asym(solution, data, params);
    fprintf('current lowest energy %3.5e\n', prevEn);        

    for iP=1:size(pairs, 1);
        
        % need to update support of all neighboring layers?       
      
        if mod(iter, 2) == iterMatch
            % move one layer in front of another
            [currData currSolution] = move_back_layer_to_front_asym(data,...
                solution, params, pairs(iP,:));
            swapPair = pairs(iP,1)+[0 1];
        else
            [currData currSolution] = move_front_layer_to_back_asym(data,...
                solution, params, pairs(iP,:));
            swapPair = pairs(iP,2)+[-1 0];
        end;        
        
        
        currData    = precompute_asym(currData, params);
        en = evaluate_overall_energy_si_asym(currSolution, currData, params);
        fprintf('pair %d energy %3.5e\t', iP, en);
        
        if ~params.isBasicMove
            %%%%% update segmentation for each layer
            currSolution = segment_layers_gc_si_asym(...
                currSolution, params, currData, swapPair  );                          
        end;
        
        enSeg = evaluate_overall_energy_si_asym(currSolution, currData, params);
        fprintf('energy %3.5e\t', enSeg);        

        %%%%% update support function for each layer        
        currSolution2 = segment_layers_change_support_gc_si_asym(...
            currSolution, params, currData, swapPair);
        en = evaluate_overall_energy_si_asym(currSolution2, currData, params);
        
        % accept the support function move if it has lower energy
        if en < enSeg
            currSolution = currSolution2;
        else
            en = enSeg;
        end;
        
        
        fprintf('energy %3.5e \t %d \n', en, en < prevEn);        
        currEn = en;

        
        %%%% if lower energy solution found, update layer index in pairs
        if currEn < prevEn            
            % 
            data     = currData;
            solution = currSolution;
            prevEn   = currEn;
            
            img = display_results_si_asym(data, solution);
            fn  = [params.fdir sprintf('change%04d.png', iChange)];            
            imwrite(uint8(img), fn);
            iChange = iChange+1;
            
            tmp_pairs = pairs;            
            if mod(iter, 2) == iterMatch
                % for moving back layer to front
                tmp_pairs(pairs == pairs(iP,1)) = pairs(iP,1)+1;
                tmp_pairs(pairs == pairs(iP,2)) = pairs(iP,1);
                % move those after 1 but before 2 one layer back
                tmp_pairs(pairs>pairs(iP,1) & pairs<pairs(iP,2)) = ...
                    tmp_pairs(pairs>pairs(iP,1) & pairs<pairs(iP,2)) + 1;
            else
                % for moving front layer to back
                tmp_pairs(pairs == pairs(iP,1)) = pairs(iP,2);
                tmp_pairs(pairs == pairs(iP,2)) = pairs(iP,2)-1;
                % move those after 1 but before 2 one layer front
                tmp_pairs(pairs>pairs(iP,1) & pairs<pairs(iP,2)) = ...
                    tmp_pairs(pairs>pairs(iP,1) & pairs<pairs(iP,2)) - 1;                
            end;

            pairs = tmp_pairs;
            % make sure the first column is in the front
            pairs = sort(pairs, 2);
            
            success = 0;
                        
        end;

        
    end;

    % remove redundant layers
    [data solution params] = prune_layers_asym(data, solution, params);
    data    = precompute_asym(data, params);

clear currData currSolution currSolution2;
    if success && (mod(iter, 2)==0) %  (iter >1) %
        break;
    end;
end;
