function display_results_si(can_uv, flow_sel, layer_support)
%%

[H W nLayers T] = size(layer_support);
nLayers = nLayers+1;

% composite flow field for each layer
tmp_layer_seg = support2seg(layer_support);
for t=1:T-1;
    for iL=1:nLayers
        layer_uv{t}(:,:,:,iL) = composite_final_flow_seg(can_uv{t},...
            flow_sel{t}(:,:,iL));
    end;
end;


t = 1;
figure; 

nRow = max(4, round(nLayers/2)*2+2);
nCol = 3;

img = zeros(H*nRow, W*nCol, 3);

r=1; c=1;
img((r-1)*H+1:r*H, (c-1)*W+1:c*W,:) = seg2color(tmp_layer_seg(:,:,t));
r=1; c=2;
uv  = composite_final_flow_seg(layer_uv{t}, tmp_layer_seg(:,:,t));
img((r-1)*H+1:r*H, (c-1)*W+1:c*W,:) = flowToColor(uv);

% flow field of each layer
c=1; 
for iL=1:nLayers   
    r=iL+1;
    img((r-1)*H+1:r*H, (c-1)*W+1:c*W,:) =...
        flowToColor(layer_uv{t}(:,:,:,iL));    
end;

% support for each layer
c=2; 
for iL=1:nLayers-1
    r=iL+1;
    img((r-1)*H+1:r*H, (c-1)*W+1:c*W,:) =...
    repmat(layer_support(:,:,iL, t), [1 1 3])*255;    
end;

% flow selection for each layer
c=3; 
for iL=1:nLayers    
    r=iL+1;
    img((r-1)*H+1:r*H, (c-1)*W+1:c*W,:) =...
    repmat(flow_sel{t}(:,:,iL), [1 1 3])*20;    
end;

if nLayers > 6
    img = [img(1:end/2, :, :) img(end/2+1:end, :, :)];
end;

if nargout > 0
    out_img = img;
end;

%imshow(uint8(img));
imagesc(uint8(img));
axis off;


% t = 1;
% figure; 
% 
% nRow = 4;
% nCol = max(3, nLayers);
% 
% % final flow field, layer segmentation, occlusion
% subplot(nRow,nCol,1); imshow(tmp_layer_seg(:,:,t), []);  
% %imagesc(tmp_layer_seg(:,:,t)); 
% axis off; title('segmentation at time t');
% 
% uv  = composite_final_flow_seg(layer_uv{t}, tmp_layer_seg(:,:,t));
% subplot(nRow,nCol,2); imshow(flowToColor(uv)); 
% title('flow field at time t');
% 
% % flow field of each layer
% for iL=1:nLayers
%     
%     subplot(nRow,nCol,iL+nCol); 
%     imshow(flowToColor(layer_uv{t}(:,:,:,iL)));
%     title(['flow field layer ' num2str(iL) ]);
% end;
% 
% % support for each layer
% for iL=1:nLayers-1
%     
%     subplot(nRow,nCol,iL+2*nCol); 
%     imshow(layer_support(:,:,iL, t), []);
%     title(['support function layer ' num2str(iL) ]);
% end;
% 
% % flow selection for each layer
% for iL=1:nLayers    
%     subplot(nRow,nCol,iL+3*nCol); 
%     imshow(flow_sel{t}(:,:,iL), []);
%     title(['flow selection layer ' num2str(iL) ]);
% end;




%%% occlusion reasoning
% for t=1:T
%     uv{t} = composite_final_flow_seg(layer_uv, tmp_layer_seg(:,:,t));
% end;
% 
% warpedSeg = warp_backward_segmentation(tmp_layer_seg(:,:,2), uv{1});
% 
% % figure;imagesc(tmp_layer_seg(:,:,1)); 
% % figure; imagesc(tmp_layer_seg(:,:,1)~=warpedSeg);
% occ = tmp_layer_seg(:,:,1)~=warpedSeg;
% seg1 = tmp_layer_seg(:,:,1);
% 
% for i=1:nLayers
%     for j=1:nLayers
%         
%         if i==j
%             continue;
%         end;
%         
%         tmp = seg1==i & warpedSeg ==j;
%         fprintf('%d %d %d\n', i,j,sum(tmp(:)));
%     end;
% end;



% t = 1;
% figure; 
% subplot(2,2,1); imagesc(tmp_layer_seg(:,:,t)); axis off;
% title('segmentation at time t');
% uv  = composite_final_flow_seg(layer_uv{t}, tmp_layer_seg(:,:,t));
% subplot(2,2,3); imshow(flowToColor(uv));
% title('flow field at time t');
% t=2;
% subplot(2,2,2); imagesc(tmp_layer_seg(:,:,t)); axis off;
% title('segmentation at time t+1');
% uv  = composite_final_flow_seg(layer_uv{t}, tmp_layer_seg(:,:,t));
% subplot(2,2,4); imshow(flowToColor(uv));
% title('flow field at time t+1');


% figure; 
% t=1;
% uv  = layer_uv{t}(:,:,:,1);
% subplot(2,2,1); imshow(flowToColor(uv));
% uv  = layer_uv{t}(:,:,:,2);
% subplot(2,2,2); imshow(flowToColor(uv));
% uv  = layer_uv{t}(:,:,:,3);
% subplot(2,2,3); imshow(flowToColor(uv));
% subplot(2,2,4);
% t=1; uv  = composite_final_flow_seg(layer_uv{t}, layer_seg(:,:,t));
% imshow(flowToColor(uv));