function [en indEn] = evaluate_energy_gc_potential_table(data_unary, pairwise_terms, new_fp)
%% 
%  evaluate energy of pairwise MRF using the potential table constructed
%  for QPBO optmization
% unary
% s = new_fp(data_unary(1,:));
% indR = 2+s;
% indC = 1:size(data_unary,2);
% ind = sub2ind([3 size(data_unary,2)], indR', indC);
% tmp = data_unary(ind);
tmp = data_unary(2,:).*(1-new_fp(:)') + data_unary(3,:).*new_fp(:)';
en  = sum(tmp);
% fprintf('unary %3.3e\t', en);
% paiwise
s1      = new_fp(pairwise_terms(1,:));
s2      = new_fp(pairwise_terms(2,:));

%indR    = 3 + s1+ s2*2;
indR    = 3 + s1*2+ s2;

%%% QPBO order 00 01 10 11, so the first row should be multiplied by two

indC    = 1:size(pairwise_terms,2);
ind     = sub2ind([6 size(pairwise_terms,2)], indR', indC);
tmp     = pairwise_terms(ind);
en      = en+sum(tmp);

if nargout == 2
    indEn = tmp;
end;