function vis = seg2visibility(seg, nL)
%%
% change the sequetial binary visibility mask to binary support functions

% this is usually not unique mapping and minimum/maximum support is adopted, i.e.
% if a pixel is occluded by pixels of front layers, its support function is
% set to be 0/1

% this function is use when switchcing layer orders: visibility of layers
% are retained while


% seg = ones(100,100);
% seg(20:50, 20:50) = 2;
% vis = seg2visibility(seg);
% figure; imshow(vis(:,:,1,1));
% figure; imshow(vis(:,:,2,1));

if nargin < 2
    nL = max(seg(:));
end;

[H W T] = size(seg);

vis = zeros(H, W, nL, T);

for t=1:T;
    for i=1:nL
        tmp = vis(:,:,i,t);
        tmp(seg(:,:,t)==i) = 1;
        vis(:,:,i,t) = tmp;
    end;
end;
