function out = update_flow_selection(prevF, currF, fp)
%% 
% combine the old result prevF with the new currF specified by fp (0 takes
% new, 1 % takes old)

%% test code
% 
% sz = [100 100 3];
% F1 = {ones(sz), ones(sz)};
% F2 = {zeros(sz), zeros(sz)};
% fp = round(randn(sz(1), sz(2), 2));
% out = update_flow_selection(F1, F2, fp(:));
% figure; imshow(squeeze(out{1}(:,:,1)) ~= fp(:,:,1));
%%

if iscell(prevF)
    
    T  = length(prevF);
    
    [H W nLayers] = size(prevF{1});    
    fp = reshape(fp, [H W T]);
    
    for t=1:T     
        tmp = repmat(fp(:,:,t), [ 1 1 nLayers]);
        
        out{t} = prevF{t}.*tmp + currF{t}.*(1-tmp);
        
    end;
    
else
    error('update_flow_selection: prevF should be cell array');
end;