function [layer_uv, layer_uvb] = inpaint_flow_possion_mf(...
    layer_g, layer_uv, layer_uvb)
%%
% solve possion equation to inpait unknown flow field
T = size(layer_g, 4);
nL = size(layer_g, 3)+1;

for t=1:T-1
    seg = g2seg(double(layer_g(:,:,1,t))-0.5);
    for iL=1:nL        
        
        uv = layer_uv{t}(:,:,:,iL);
        for i=1:size(uv,3)
            uv(:,:,i) = possion_inpaint(uv(:,:,i), seg==iL);
        end

        layer_uv{t}(:,:,:,iL) = uv;
        
    end;
end;

for t=1:T-1
    seg = g2seg(double(layer_g(:,:,1,t+1))-0.5);
    for iL=1:nL        
        uv = layer_uvb{t}(:,:,:,iL);
        for i=1:size(uv,3)
            uv(:,:,i) = possion_inpaint(uv(:,:,i), seg==iL);
        end
        layer_uvb{t}(:,:,:,iL) = uv;        
    end;
end;