function curr_layer_q = pass_message_flow_backward(mfParams, curr_layer_q,...
    layer_q, dataCostB, BLMtxB, warpedDataCostB, T, nValues)
%%
%   - warping
for t=2:T % current frame to change
    for qID = 1:nValues
        %data cost
        neigh_q = layer_q(:,:,1,t-1,qID);
        
        if mfParams.datatermOn
            layerID = qID;        
            curr_layer_q(:,:,1,t,qID) = curr_layer_q(:,:,1,t,qID) +...
                dataCostB{t-1}{layerID}.*...
                reshape(BLMtxB{t-1}{layerID}*neigh_q(:), size(neigh_q));
        end;
        % temporal
        neigh_q = layer_q(:,:,1,t-1,nValues+1-qID);
        layerID = 1;
        curr_layer_q(:,:,1,t,qID) = curr_layer_q(:,:,1,t,qID)+...
            mfParams.lambdaTemp*...
            reshape(BLMtxB{t-1}{layerID}*neigh_q(:), size(neigh_q));
    end;
end;


%   -transpose of warping
for t=1:T-1
    
    for qID = 1:nValues
        %data cost
        neigh_q = squeeze(layer_q(:,:,1,t+1,qID));
        if mfParams.datatermOn
            layerID = qID;     
            tmp = neigh_q.*dataCostB{t}{layerID};
            
            curr_layer_q(:,:,1,t,qID) = curr_layer_q(:,:,1,t,qID) +...
                reshape(BLMtxB{t}{layerID}'*tmp(:), size(neigh_q));
            
        end;
        % temporal
        % two-layer case
        neigh_q = squeeze(layer_q(:,:,1,t+1,nValues+1-qID)); 
        layerID = 1;
        curr_layer_q(:,:,1,t,qID) = curr_layer_q(:,:,1,t,qID)+...
            mfParams.lambdaTemp*...
            reshape(BLMtxB{t}{layerID}'*neigh_q(:), size(neigh_q));
    end;
end;