function curr_q = pass_message_flow_backward_one_frame(mfParams,...
    layer_q, dataCostB, BLMtxB, warpedDataCostB, t, T, nValues, curr_q)
%%
%   - warping

if t >1
    for qID = 1:nValues
        %data cost
        neigh_q = layer_q(:,:,1,t-1,qID);
        
        if mfParams.datatermOn
            layerID = qID;        
            curr_q(:,:,:,:,qID) = curr_q(:,:,:,:,qID)+...
                dataCostB{t-1}{layerID}.*...
                reshape(BLMtxB{t-1}{layerID}*neigh_q(:), size(neigh_q));
        end;
        % temporal
        neigh_q = layer_q(:,:,1,t-1,nValues+1-qID);
        layerID = 1;
        curr_q(:,:,:,:,qID) = curr_q(:,:,:,:,qID) + ...
            mfParams.lambdaTemp*...
            reshape(BLMtxB{t-1}{layerID}*neigh_q(:), size(neigh_q));
    end;
end;


%   -transpose of warping
if t < T    
    for qID = 1:nValues
        %data cost
        neigh_q = squeeze(layer_q(:,:,1,t+1,qID));
        if mfParams.datatermOn
            layerID = qID;     
            tmp = neigh_q.*dataCostB{t}{layerID};
            
            curr_q(:,:,:,:,qID) = curr_q(:,:,:,:,qID) + ...
                reshape(BLMtxB{t}{layerID}'*tmp(:), size(neigh_q));
            
        end;
        % temporal
        % two-layer case
        neigh_q = squeeze(layer_q(:,:,1,t+1,nValues+1-qID)); 
        layerID = 1;
        curr_q(:,:,:,:,qID) = curr_q(:,:,:,:,qID) + mfParams.lambdaTemp*...
            reshape(BLMtxB{t}{layerID}'*neigh_q(:), size(neigh_q));
    end;
end;