function bb = track_blob(curr_blob_map, class_idx, next_segmentation)



% clean inext frame segmentation
se = strel('disk',8,4);
class_mask = (next_segmentation==class_idx);
class_mask = imdilate(class_mask,se);
class_mask = imerode(class_mask,se);
class_mask = remove_small_blobs(class_mask);
			
if sum(class_mask(:)) > 0
	[L, num_objects] = bwlabel(class_mask);

	% choose the blob that overlaps most 
	chosen_idx = 1; 
	max_overlap = 0; 	
	for i=1:num_objects
		%keyboard;
		overlap = (L == i)&curr_blob_map; 
		overlap_size = sum(overlap(:)); 
		if overlap_size > max_overlap 
			max_overlap = overlap_size; 
			chosen_idx = i;
		end
	end

	% compute the bounding box around it 
	[row, col] = find(L == chosen_idx); 
        bb = [min(row(:)), min(col(:)), (max(row(:)) - min(row(:))), (max(col(:)) - min(col(:)))];
else 
	bb = [];
end











