function y = middle_robust(x, sigma, type)

% between a and b, less penalty 

%   TYPE selects the evaluation type:
%    - 0: function value
%    - 1: first derivative
%    - 2: second derivative


a = sigma(1);
b = sigma(2);
c = min(sigma(3), b^2-a^2);

ind = abs(x) > a & abs(x) < b;
ind2 = abs(x) >=b;

  switch (type)
    case 0
        y = x.^2;
        y(ind) = a^2 + (x(ind).^2 - a^2) * (b^2-a^2 - c)/(b^2-a^2);
        
        y(ind2) = x(ind2).^2 -c;
   case 1
       y = 2*x;
       y(ind) = 2*x(ind)*(b^2-a^2 - c)/(b^2-a^2);
   case 2
       y = repmat(2, size(x));
       y(ind) = 2*(b^2-a^2 - c)/(b^2-a^2);
  end  
