function [e d12] = compute_hidden_field_3D_energy(g12, aIt2, colorImages, aIt2_b, layer_uvb, layer_uv, this)

% Data + smoothness prior + temporal consistency term

% for 2 frames symmetric case, solve g g2 together
%%
% clear
% T = 2;
% nL = 4;
% sz = [10 10];
% 
% params.sigma_i = 7;
% params.Ti2     = 20^2;
% params.g_filters   = {[1 -1], [1; -1]};  
% params.kappa = 0.5;
% params.lambda2 = 1;
% params.lambda3 = 1;  
% params.lambda4 = 1;
% 
% g12  = randn([sz  nL-1 T]);
% g12 = g12(:);
% % for t=1:T; colorImages{t} = randn([sz 3]);end;
% for t=1:T; colorImages{t} = randn([sz]);end;
% for t=1:T-1;
%     for i = 1:nL; layer_uvb{t}{i} = randn([sz 2]); end;
%     for i = 1:nL; layer_uv{t}{i} = randn([sz 2]); end;
%     aIt2{t} = rand([sz nL])*10;
%     aIt2_b{t} = rand([sz nL])*10;
% end;
%
% d = checkgrad('compute_hidden_field_3D_energy', g12, 1e-3, aIt2, colorImages, aIt2_b, layer_uvb, layer_uv, params)


% d = checkgrad('compute_g_con_sim_energy', g12, 1e-3, aIt2{1}, colorImages{1}(:,:,1), colorImages{2}(:,:,1), params.g_filters,...
%                params.kappa, params.lambda2, params.lambda3, params.lambda4, aIt2_b{1}, layer_uvb{1}, layer_uv{1})

%[e d] = compute_g_con_sim_energy(g12, aIt2{1}, colorImages{1}(:,:,1), colorImages{2}(:,:,1), params.g_filters, params.kappa, params.lambda2, params.lambda3, params.lambda4, aIt2_b{1}, layer_uvb{1}, layer_uv{1});

%[e2 d2] = compute_hidden_field_3D_energy(g12, aIt2, colorImages, aIt2_b, layer_uvb, layer_uv, params);
%%
sigma_i = this.sigma_i;
Ti2     = this.Ti2; %20^2;
F       = this.g_filters;
kappa   = this.kappa;
lambda  = this.lambda2;
lambda_g = this.lambda3;
lambda_s = this.lambda4;


sz = size(aIt2{1});
nL = sz(3);
sz = sz(1:2);
T  = length(layer_uv)+1;
n  = numel(g12)/T;
for t=1:T
    g{t} = reshape(g12((t-1)*n+1:t*n), [sz nL-1]);        
    s{t} = g2labels(g{t}, lambda_s);
end;

% Compute energy

for t=1:T-1
    
    % warp hidden field and layer using FORWARD flow field    
    for i = 1:nL-1
        warpg_f{t}(:,:,i) = imwarp_grad_im(layer_uv{t}{i}, g{t+1}(:,:,i));
    end;
    %warpg_f{t}(isnan(warpg_f{t})) = g{t+1}(isnan(warpg_f{t}));
    warpg_f{t}(isnan(warpg_f{t})) = g{t}(isnan(warpg_f{t}));
    
    % warp toward g{t}, out-of-boundary replicate g{t}
    
    
    for i = 1:nL
        warps_f{t}(:,:,i) = imwarp_grad_im(layer_uv{t}{i}, s{t+1}(:,:,i));        
    end;
    warps_f{t}(isnan(warps_f{t})) = 0;
    
    
    % warp hidden field and layer using BACKWARD flow field
    for i = 1:nL-1
        warpg_b{t}(:,:,i) = imwarp_grad_im(layer_uvb{t}{i}, g{t}(:,:,i));
    end;
    %warpg_b{t}(isnan(warpg_b{t})) = g{t}(isnan(warpg_b{t}));
    warpg_b{t}(isnan(warpg_b{t})) = g{t+1}(isnan(warpg_b{t}));
    
    for i = 1:nL
        warps_b{t}(:,:,i) = imwarp_grad_im(layer_uvb{t}{i}, s{t}(:,:,i));        
    end;
    warps_b{t}(isnan(warps_b{t})) = 0;    
end;

e = 0;
% data term
for t=1:T-1
    % forward flow field
    e = e+ sum(aIt2{t}(:).*s{t}(:).*warps_f{t}(:));
    % backward flow field
    e = e+ sum(aIt2_b{t}(:).*s{t+1}(:).*warps_b{t}(:));
end;

% spatial term
seg = colorImages;
for t=1:T
    for i = 1:length(F)
        
        if size(seg{t},3) ==1
            % weighte by segmentation difference
            seg_ = conv2(seg{t}, F{i}, 'valid');
            seg_ = 1 - kappa*(seg_==0);
        else
            % weighted by lab color difference
            fsz = size(F{i});
            seg_ = zeros(sz(1)-fsz(1)+1, sz(2)-fsz(2)+1);
            for i1 = 1:size(seg{t},3)
                seg_ = seg_ + conv2(seg{t}(:,:,i1), F{i}, 'valid').^2;
            end;
            seg_(seg_>Ti2) = Ti2;
            seg_ = exp(-seg_/2/sigma_i^2);
        end;
        
        if nargout > 1
            % back up for gradient computation
            seg__{t}{i} = seg_;
        end;
        
        for j = 1:nL-1
            g_ = conv2(g{t}(:,:,j), F{i}, 'valid');
            e   = e + lambda * sum(g_(:).^2.*seg_(:));
        end;
    end;
end;

% consistency term
for t=1:T-1
    % forward flow field
    e = e + lambda_g*sum((g{t}(:)-warpg_f{t}(:)).^2);
    % backward flow field
    e = e + lambda_g*sum((g{t+1}(:)-warpg_b{t}(:)).^2);
end;

if nargout > 1
    
    % Compute derivative     
    
    %%%%% derivative w.r.t. g    
    
    % spatial term
    for t=1:T         
        d = zeros(size(g{t}));                
        for i = 1:length(F)
            seg_ = seg__{t}{i};
            Fi  = reshape(F{i}(end:-1:1), size(F{i}));
            for j = 1:nL-1
                g_  = conv2(g{t}(:,:,j), F{i}, 'valid');
                tmp = conv2(2*g_.*seg_, Fi, 'full');
                d(:,:,j)   = d(:,:,j) + lambda * tmp;
            end;
        end;
        all_d{t} = d;
    end;

    % forward flow field
    for t=1:T-1
        d = zeros(size(g{t})); 
        % data term at current frame
        for j = 1:nL-1
            d(:,:,j) = aIt2{t}(:,:,j).*warps_f{t}(:,:,j).*s{t}(:,:,j)...
                .*sigmoid(g{t}(:,:,j),2,lambda_s)./sigmoid(g{t}(:,:,j),1,lambda_s); % = lambda_4 sigmoid(-g(:,:,j),1)
            
            d(:,:,j) = d(:,:,j) - sum(aIt2{t}(:,:,j+1:nL).*warps_f{t}(:,:,j+1:nL).*s{t}(:,:,j+1:nL), 3)...
                .*sigmoid(g{t}(:,:,j),2,lambda_s)./sigmoid(-g{t}(:,:,j),1,lambda_s);  % = lambda_4 sigmoid(g(:,:,j),1)
        end;
        % consistency term at current frame
        d = d + 2*lambda_g*(g{t}-warpg_f{t});
        
        all_d{t} = all_d{t}+d;
    end;
        
    for t=2:T
        d = zeros(size(g{t}));
        
        % data term at previous frame
        for j = 1:nL
            tmp = aIt2{t-1}(:,:,j).*s{t-1}(:,:,j);
            aIt2_bw(:,:,j) = imwarp_adjoint_operator(layer_uv{t-1}{j}(:,:,1), layer_uv{t-1}{j}(:,:,2), tmp);
        end;        
        for j = 1:nL-1
            d(:,:,j) = aIt2_bw(:,:,j).*s{t}(:,:,j)...
                .*sigmoid(g{t}(:,:,j),2,lambda_s)./sigmoid(g{t}(:,:,j),1,lambda_s); % = lambda_4 sigmoid(-g(:,:,j),1)
            
            d(:,:,j) = d(:,:,j) - sum(aIt2_bw(:,:,j+1:nL).*s{t}(:,:,j+1:nL), 3)...
                .*sigmoid(g{t}(:,:,j),2,lambda_s)./sigmoid(-g{t}(:,:,j),1,lambda_s);  % = lambda_4 sigmoid(g(:,:,j),1)
        end;        
        
        %consistency term at previous frame        
        for i= 1:nL-1
            tmp = 2*lambda_g*(warpg_f{t-1}(:,:,i)-g{t-1}(:,:,i));
            d(:,:,i) = d(:,:,i) + imwarp_adjoint_operator(layer_uv{t-1}{i}(:,:,1), layer_uv{t-1}{i}(:,:,2), tmp);
        end;
        
        all_d{t} = all_d{t}+d;        
    end;
    
    % backward flow field
    for t=2:T
        d = zeros(size(g{t}));        
        
        % data term at current frame
        for j = 1:nL-1
            d(:,:,j) = aIt2_b{t-1}(:,:,j).*warps_b{t-1}(:,:,j).*s{t}(:,:,j)...
                .*sigmoid(g{t}(:,:,j),2,lambda_s)./sigmoid(g{t}(:,:,j),1,lambda_s); % = lambda_4 sigmoid(-g(:,:,j),1)            
            d(:,:,j) = d(:,:,j) - sum(aIt2_b{t-1}(:,:,j+1:nL).*warps_b{t-1}(:,:,j+1:nL).*s{t}(:,:,j+1:nL), 3)...
                .*sigmoid(g{t}(:,:,j),2,lambda_s)./sigmoid(-g{t}(:,:,j),1,lambda_s);  % = lambda_4 sigmoid(g(:,:,j),1)
        end;
        
        % consistency term at current frame
        d = d + 2*lambda_g*(g{t}-warpg_b{t-1});
       
        all_d{t} = all_d{t}+d;
    end;
    
    for t=1:T-1
        
        d = zeros(size(g{t}));
        % data term at next frame
        for j = 1:nL
            tmp = aIt2_b{t}(:,:,j).*s{t+1}(:,:,j);
            aIt2_bw(:,:,j) = imwarp_adjoint_operator(layer_uvb{t}{j}(:,:,1), layer_uvb{t}{j}(:,:,2), tmp);
        end;
        
        for j = 1:nL-1            
            d(:,:,j) = d(:,:,j) + aIt2_bw(:,:,j).*s{t}(:,:,j)... 
                .*sigmoid(g{t}(:,:,j),2,lambda_s)./sigmoid(g{t}(:,:,j),1,lambda_s); % = lambda_4 sigmoid(-g(:,:,j),1)
            
            d(:,:,j) = d(:,:,j) - sum(aIt2_bw(:,:,j+1:nL).*s{t}(:,:,j+1:nL), 3)...
                .*sigmoid(g{t}(:,:,j),2,lambda_s)./sigmoid(-g{t}(:,:,j),1,lambda_s);  % = lambda_4 sigmoid(g(:,:,j),1)
        end;
   
        % consistency term at next frame
        for i= 1:nL-1
            tmp = 2*lambda_g*(warpg_b{t}(:,:,i)-g{t+1}(:,:,i));
            d(:,:,i) = d(:,:,i) + imwarp_adjoint_operator(layer_uvb{t}{i}(:,:,1), layer_uvb{t}{i}(:,:,2), tmp);
        end;       
 
        all_d{t} = all_d{t}+d;

    end;
    
    d12 = zeros(size(g12));
    d12 = d12(:);
    n = numel(g12)/T;
    for t=1:T
        d12((t-1)*n+1:t*n) = all_d{t}(:);
    end;
        
end;
% function [e d12] = compute_hidden_field_3D_energy(g12, aIt2, colorImages, aIt2_b, layer_uvb, layer_uv, this)
% 
% % Data + smoothness prior + temporal consistency term
% 
% % for 2 frames symmetric case, solve g g2 together
% %%
% % clear
% % T = 2;
% % nL = 4;
% % sz = [10 10];
% % 
% % params.sigma_i = 7;
% % params.Ti2     = 20^2;
% % params.g_filters   = {[1 -1], [1; -1]};  
% % params.kappa = 0.5;
% % params.lambda2 = 1;
% % params.lambda3 = 1;  
% % params.lambda4 = 1;
% % 
% % g12  = randn([sz  nL-1 T]);
% % g12 = g12(:);
% % % for t=1:T; colorImages{t} = randn([sz 3]);end;
% % for t=1:T; colorImages{t} = randn([sz]);end;
% % for t=1:T-1;
% %     for i = 1:nL; layer_uvb{t}{i} = randn([sz 2]); end;
% %     for i = 1:nL; layer_uv{t}{i} = randn([sz 2]); end;
% %     aIt2{t} = rand([sz nL])*10;
% %     aIt2_b{t} = rand([sz nL])*10;
% % end;
% %%
% % d = checkgrad('compute_hidden_field_3D_energy', g12, 1e-3, aIt2, colorImages, aIt2_b, layer_uvb, layer_uv, params)
% 
% 
% % d = checkgrad('compute_g_con_sim_energy', g12, 1e-3, aIt2{1}, colorImages{1}(:,:,1), colorImages{2}(:,:,1), params.g_filters,...
% %                params.kappa, params.lambda2, params.lambda3, params.lambda4, aIt2_b{1}, layer_uvb{1}, layer_uv{1})
% 
% %[e d] = compute_g_con_sim_energy(g12, aIt2{1}, colorImages{1}(:,:,1), colorImages{2}(:,:,1), params.g_filters, params.kappa, params.lambda2, params.lambda3, params.lambda4, aIt2_b{1}, layer_uvb{1}, layer_uv{1});
% 
% %[e2 d2] = compute_hidden_field_3D_energy(g12, aIt2, colorImages, aIt2_b, layer_uvb, layer_uv, params);
% 
% sigma_i = this.sigma_i;
% Ti2     = this.Ti2; %20^2;
% F       = this.g_filters;
% kappa   = this.kappa;
% lambda  = this.lambda2;
% lambda_g = this.lambda3;
% lambda_s = this.lambda4;
% 
% 
% sz = size(aIt2{1});
% nL = sz(3);
% sz = sz(1:2);
% T  = length(layer_uv)+1;
% n  = numel(g12)/T;
% for t=1:T
%     g{t} = reshape(g12((t-1)*n+1:t*n), [sz nL-1]);        
%     s{t} = g2labels(g{t}, lambda_s);
% end;
% 
% % Compute energy
% 
% for t=1:T-1
%     
%     % warp hidden field and layer using FORWARD flow field    
%     for i = 1:nL-1
%         warpg_f{t}(:,:,i) = imwarp_grad_im(layer_uv{t}{i}, g{t+1}(:,:,i));
%     end;
%     %warpg_f{t}(isnan(warpg_f{t})) = g{t+1}(isnan(warpg_f{t}));
%     warpg_f{t}(isnan(warpg_f{t})) = g{t}(isnan(warpg_f{t}));
%     
%     % warp toward g{t}, out-of-boundary replicate g{t}
%     
%     
%     for i = 1:nL
%         warps_f{t}(:,:,i) = imwarp_grad_im(layer_uv{t}{i}, s{t+1}(:,:,i));        
%     end;
%     warps_f{t}(isnan(warps_f{t})) = 0;
%     
%     
%     % warp hidden field and layer using BACKWARD flow field
%     for i = 1:nL-1
%         warpg_b{t}(:,:,i) = imwarp_grad_im(layer_uvb{t}{i}, g{t}(:,:,i));
%     end;
%     %warpg_b{t}(isnan(warpg_b{t})) = g{t}(isnan(warpg_b{t}));
%     warpg_b{t}(isnan(warpg_b{t})) = g{t+1}(isnan(warpg_b{t}));
%     
%     for i = 1:nL
%         warps_b{t}(:,:,i) = imwarp_grad_im(layer_uvb{t}{i}, s{t}(:,:,i));        
%     end;
%     warps_b{t}(isnan(warps_b{t})) = 0;    
% end;
% 
% e = 0;
% % data term
% for t=1:T-1
%     % forward flow field
%     e = e+ sum(aIt2{t}(:).*s{t}(:).*warps_f{t}(:));
%     % backward flow field
%     e = e+ sum(aIt2_b{t}(:).*s{t+1}(:).*warps_b{t}(:));
% end;
% 
% % spatial term
% seg = colorImages;
% for t=1:T
%     for i = 1:length(F)
%         
%         if size(seg{t},3) ==1
%             % weighte by segmentation difference
%             seg_ = conv2(seg{t}, F{i}, 'valid');
%             seg_ = 1 - kappa*(seg_==0);
%         else
%             % weighted by lab color difference
%             fsz = size(F{i});
%             seg_ = zeros(sz(1)-fsz(1)+1, sz(2)-fsz(2)+1);
%             for i1 = 1:size(seg{t},3)
%                 seg_ = seg_ + conv2(seg{t}(:,:,i1), F{i}, 'valid').^2;
%             end;
%             seg_(seg_>Ti2) = Ti2;
%             seg_ = exp(-seg_/2/sigma_i^2);
%         end;
%         
%         % back up for gradient computation
%         seg__{t}{i} = seg_;
%         
%         for j = 1:nL-1
%             g_ = conv2(g{t}(:,:,j), F{i}, 'valid');
%             e   = e + lambda * sum(g_(:).^2.*seg_(:));
%         end;
%     end;
% end;
% 
% % consistency term
% for t=1:T-1
% %     % forward flow field
% %     e = e + lambda_g*sum((g{t}(:)-warpg_f{t}(:)).^2);
% %     % backward flow field
% %     e = e + lambda_g*sum((g{t+1}(:)-warpg_b{t}(:)).^2);
% 
%     % forward flow field
%     e = e + lambda_g*sum((g{t}(:)-warpg_f{t}(:)).^2);
%     % backward flow field
%     e = e + lambda_g*sum((g{t+1}(:)-warpg_b{t}(:)).^2);
% end;
% 
% if nargout > 1
%     
%     % Compute derivative     
%     
%     %%%%% derivative w.r.t. g    
%     
%     % spatial term
%     for t=1:T         
%         d = zeros(size(g{t}));                
%         for i = 1:length(F)
%             seg_ = seg__{t}{i};
%             Fi  = reshape(F{i}(end:-1:1), size(F{i}));
%             for j = 1:nL-1
%                 g_  = conv2(g{t}(:,:,j), F{i}, 'valid');
%                 tmp = conv2(2*g_.*seg_, Fi, 'full');
%                 d(:,:,j)   = d(:,:,j) + lambda * tmp;
%             end;
%         end;
%         all_d{t} = d;
%     end;
% 
%     % forward flow field
%     for t=1:T-1
%         d = zeros(size(g{t})); 
%         % data term at current frame
%         for j = 1:nL-1
%             d(:,:,j) = aIt2{t}(:,:,j).*warps_f{t}(:,:,j).*s{t}(:,:,j)...
%                 .*sigmoid(g{t}(:,:,j),2,lambda_s)./sigmoid(g{t}(:,:,j),1,lambda_s); % = lambda_4 sigmoid(-g(:,:,j),1)
%             
%             d(:,:,j) = d(:,:,j) - sum(aIt2{t}(:,:,j+1:nL).*warps_f{t}(:,:,j+1:nL).*s{t}(:,:,j+1:nL), 3)...
%                 .*sigmoid(g{t}(:,:,j),2,lambda_s)./sigmoid(-g{t}(:,:,j),1,lambda_s);  % = lambda_4 sigmoid(g(:,:,j),1)
%         end;
%         % consistency term at current frame
%         d = d + 2*lambda_g*(g{t}-warpg_f{t});
%         
%         all_d{t} = all_d{t}+d;
%     end;
%         
%     for t=2:T
%         d = zeros(size(g{t}));
%         
%         % data term at previous frame
%         for j = 1:nL
%             tmp = aIt2{t-1}(:,:,j).*s{t-1}(:,:,j);
%             aIt2_bw(:,:,j) = imwarp_adjoint_operator(layer_uv{t-1}{j}(:,:,1), layer_uv{t-1}{j}(:,:,2), tmp);
%         end;        
%         for j = 1:nL-1
%             d(:,:,j) = aIt2_bw(:,:,j).*s{t}(:,:,j)...
%                 .*sigmoid(g{t}(:,:,j),2,lambda_s)./sigmoid(g{t}(:,:,j),1,lambda_s); % = lambda_4 sigmoid(-g(:,:,j),1)
%             
%             d(:,:,j) = d(:,:,j) - sum(aIt2_bw(:,:,j+1:nL).*s{t}(:,:,j+1:nL), 3)...
%                 .*sigmoid(g{t}(:,:,j),2,lambda_s)./sigmoid(-g{t}(:,:,j),1,lambda_s);  % = lambda_4 sigmoid(g(:,:,j),1)
%         end;        
%         
%         %consistency term at previous frame        
%         for i= 1:nL-1
%             tmp = 2*lambda_g*(warpg_f{t-1}(:,:,i)-g{t-1}(:,:,i));
%             d(:,:,i) = d(:,:,i) + imwarp_adjoint_operator(layer_uv{t-1}{i}(:,:,1), layer_uv{t-1}{i}(:,:,2), tmp);
%         end;
%         
%         all_d{t} = all_d{t}+d;        
%     end;
%     
%     % backward flow field
%     for t=2:T
%         d = zeros(size(g{t}));        
%         
%         % data term at current frame
%         for j = 1:nL-1
%             d(:,:,j) = aIt2_b{t-1}(:,:,j).*warps_b{t-1}(:,:,j).*s{t}(:,:,j)...
%                 .*sigmoid(g{t}(:,:,j),2,lambda_s)./sigmoid(g{t}(:,:,j),1,lambda_s); % = lambda_4 sigmoid(-g(:,:,j),1)            
%             d(:,:,j) = d(:,:,j) - sum(aIt2_b{t-1}(:,:,j+1:nL).*warps_b{t-1}(:,:,j+1:nL).*s{t}(:,:,j+1:nL), 3)...
%                 .*sigmoid(g{t}(:,:,j),2,lambda_s)./sigmoid(-g{t}(:,:,j),1,lambda_s);  % = lambda_4 sigmoid(g(:,:,j),1)
%         end;
%         
%         % consistency term at current frame
%         d = d + 2*lambda_g*(g{t}-warpg_b{t-1});
%        
%         all_d{t} = all_d{t}+d;
%     end;
%     
%     for t=1:T-1
%         
%         d = zeros(size(g{t}));
%         % data term at next frame
%         for j = 1:nL
%             tmp = aIt2_b{t}(:,:,j).*s{t+1}(:,:,j);
%             aIt2_bw(:,:,j) = imwarp_adjoint_operator(layer_uvb{t}{j}(:,:,1), layer_uvb{t}{j}(:,:,2), tmp);
%         end;
%         
%         for j = 1:nL-1            
%             d(:,:,j) = d(:,:,j) + aIt2_bw(:,:,j).*s{t}(:,:,j)... 
%                 .*sigmoid(g{t}(:,:,j),2,lambda_s)./sigmoid(g{t}(:,:,j),1,lambda_s); % = lambda_4 sigmoid(-g(:,:,j),1)
%             
%             d(:,:,j) = d(:,:,j) - sum(aIt2_bw(:,:,j+1:nL).*s{t}(:,:,j+1:nL), 3)...
%                 .*sigmoid(g{t}(:,:,j),2,lambda_s)./sigmoid(-g{t}(:,:,j),1,lambda_s);  % = lambda_4 sigmoid(g(:,:,j),1)
%         end;
% 
%    
%         % consistency term at next frame
%         for i= 1:nL-1
%             tmp = 2*lambda_g*(warpg_b{t}(:,:,i)-g{t+1}(:,:,i));
%             d(:,:,i) = d(:,:,i) + imwarp_adjoint_operator(layer_uvb{t}{i}(:,:,1), layer_uvb{t}{i}(:,:,2), tmp);
%         end;       
%  
%         all_d{t} = all_d{t}+d;
% 
%     end;
% % % % % consistency term at previous frame
% % % %     for i= 1:nL-1
% % % %         tmp = 2*lambda_g*(warpg(:,:,i)-g2(:,:,i));
% % % %         d(:,:,i) = d(:,:,i) + imwarp_adjoint_operator(layer_uv2{i}(:,:,1), layer_uv2{i}(:,:,2), tmp);
% % % %     end;
% % % %         
% % % % consistency term
% % % for t=1:T-1
% % %     % forward flow field
% % % %     e = e + lambda_g*sum((g{t}(:)-warpg_f{t}(:)).^2);
% % %     % backward flow field
% % %     e = e + lambda_g*sum((g{t+1}(:)-warpg_b{t}(:)).^2);
% % % end;
% 
%     d12 = zeros(size(g12));
%     d12 = d12(:);
%     n = numel(g12)/T;
%     for t=1:T
%         d12((t-1)*n+1:t*n) = all_d{t}(:);
%     end;
%         
% end;