function uo = weighted_median(w, u)

% compute the weighted median 
%   uo = \min_u \sum w(i)|uo - u(i)| 
% using the formula (3.13) in
%   Y. Li and Osher "A New Median Formula with Applications to PDE Based
%   Denoising"

% applied to every corresponding columns of w and u

%%

% for k = 1:100;
% u = rand(280, 4000);
[H W] = size(u);
%fprintf('%d\t', sum(isnan(u(:))) ); %fprintf('\n');
[sort_u ir] = sort(u);
ic       = repmat(1:W, [H, 1]);
ind      = sub2ind([H W], ir, ic);

% fprintf('%d\t', [size(ind) H W]);fprintf('\n');
% u        = u(ind);
% end;
%%
w        = w(ind);

% p  = repmat(sum(w), [H+1, 1]);
% for i = 2:H+1;
%     p(i,:) = p(i-1, :) - 2*w(i-1, :);
% end;
% k   = sum(p < 0);

% number of negative infinites for each column
k = ones(1, W);
pp = -sum(w);
for i = H:-1:1;
    pc = pp + 2*w(i, :);
    indx = (pc > 0) & (pp < 0);
    k(indx) = H-i+1;
    pp = pc;
end;

k   = H-k+1;
ind = sub2ind([H W], k, 1:W);

uo  = sort_u(ind);


%%%%%%%%%%%%%%%%%% First version for test
% 
% infinit = (max(u)-min(u)) * 1e5; 
% 
% [tmp ix] = sort(u);
% w1 = w(ix);
% 
% p  = ones(length(u)+1, 1) * sum(w1);
% 
% for i = 2:length(p);
%     p(i) = p(i-1) - 2*w1(i-1);
% end;
% 
% p  = infinit *  p/min(abs(p));
% 
% uo = median([u; p]);