function out = compute_pw_t_layer_nlabels_potential(vals, ...
    matchCost, other_seg, seg_id, params, OOB, selected)
%%
% Compute the temporal pairwise term for layer segmentation


H = size(other_seg,1);
W = size(other_seg,2);
nCan = size(OOB,3);

ind1 = vals(1,:);

if (ind1(1,1)>H*W)
    % from t+1 to t data term
    ind1 = ind1-H*W;        
end;


% compute binary fusion label from collapsed state
segIndex = vals(3:4,:)+1;

tmp_ind = ind1 + (segIndex(1,:)-1)*H*W;

    
out  = matchCost(tmp_ind);
oob  = OOB(tmp_ind);

occ  = segIndex(1,:) > segIndex(2,:); 
forb = segIndex(1,:) < segIndex(2,:); 

out(occ)  = params.lambdaOcc; 
out(forb) = params.lambdaForbid;

% treat out-of-boundary pixels as occluded
out(oob==1) = params.lambdaOcc;


% disable temporal data terms that are not activated

nBatch = size(vals,2)/nCan;
disabled = zeros(size(out));

for iCan=1:nCan;    
    invalid = segIndex(1, (iCan-1)*nBatch+1:iCan*nBatch ) ~= iCan;    
    disabled((iCan-1)*nBatch+1:iCan*nBatch) = invalid;
end;    
% fprintf('%3.3f ', sum(disabled)/length(disabled)); % for debug
out(disabled==1) = 0;