function out = compute_pw_t_layer_potential(vals, ...
    matchCost, other_seg, seg_id, params, OOB, selected)
%%
% Compute the temporal pairwise term for layer segmentation


H = size(other_seg,1);
W = size(other_seg,2);
nCan = size(OOB,3);

ind1 = vals(1,:);

if (ind1(1,1)>H*W)
    % from t+1 to t data term
    ind1 = ind1-H*W;        
end;

ind2 = vals(2,:);
if (ind2(1,1)>H*W)
    % from t to t+1 data term
    ind2 = ind2-H*W;        
end;

% compute binary fusion label from collapsed state
segIndex = vals(3:4,:)+1;

% segIndex(vals(3:4,:)==0) = seg_id(1);
% segIndex(vals(3:4,:)==1) = seg_id(2);

% replace unselected pixels by their original labels
% pixels in current frames are all selected, only need to check the other
% frame


tmp_ind = ind1 + (segIndex(1,:)-1)*H*W;

% [max(tmp_ind(:)) size(matchCost)]
    
out  = matchCost(tmp_ind);
oob  = OOB(tmp_ind);
tmp  = segIndex(2,:);
tmp_seg = other_seg(ind2);
unselected = ~selected(ind2);
tmp(unselected) = tmp_seg(unselected);
segIndex(2,:) = tmp;

occ  = segIndex(1,:) > segIndex(2,:); 
forb = segIndex(1,:) < segIndex(2,:); 

out(occ)  = params.lambdaOcc; 
out(forb) = params.lambdaForbid;

% treat out-of-boundary pixels as occluded
% tmp_ind = ind1 + segIndex(1,:)*H*W;
out(oob==1) = params.lambdaOcc;


% disable temporal data terms that are not activated

% flowIndex tells whether a pixel selects a particular candidate flow
% the matchCost plays a role only for the selected flow candidate

nBatch = size(vals,2)/nCan;
disabled = zeros(size(out));

for iCan=1:nCan;    
    invalid = segIndex(1, (iCan-1)*nBatch+1:iCan*nBatch ) ~= iCan;    
    disabled((iCan-1)*nBatch+1:iCan*nBatch) = invalid;
end;    
% fprintf('%3.3f ', sum(disabled)/length(disabled)); % for debug
out(disabled==1) = 0;