function  en = evaluate_overall_energy(layer_seg, flow_sel, data,...
                params, can_uv)
%%  some computations are redundant for sanity check reasons

% parse data                        
[H W n nCan] = size(can_uv{1});
nLayers = size(flow_sel{1},3);


ind = reshape(1:H*W, [H W]);
for t=1:params.T    
    for i = 1:nLayers
        
        id = i;        
        flow_seg = flow_sel{t}(:,:,id);
        layer_uv{t}(:,:,:,i) = composite_final_flow_seg(can_uv{t},...
            flow_seg);        
       
%         tmp_ind = ind + (flow_sel{t}(:,:,id)-1)*H*W;        
%         matchCost{t}(:,:,i)= reshape(data.matchCost{t}(tmp_ind), [H W]);
%         OOB{t}(:,:,i)      = reshape(data.OOB{t}(tmp_ind), [H W]);                   
%         
%         neigh = data.tempNeighbors{t}(:,:,1);        
%         for iL = 2:length(all_can_uv)
%             tmp = data.tempNeighbors{t}(:,:,iL);
%             mask = flow_sel{t}(:,:,id) == iL;
%             neigh(mask) = tmp(mask);                        
%         end;
%         tempNeighbors{t}(:,:,i) = neigh;       
        
    end;        
end;

enFlow=0;
Dx = [1 -1];
Dy = Dx';
% flow smoothness
for t=1:params.T    
    for i = 1:nLayers
        for j=1:2
            tmp = layer_uv{t}(:,:,j,i);
            
            % horizontal derivative
            tmpx = conv2(tmp, Dx, 'valid');
            enFlow = enFlow + sum( evaluate(params.rho_spatial, tmpx(:)) );
            
            % vertical derivative
            tmpy = conv2(tmp, Dy, 'valid');
            enFlow = enFlow + sum( evaluate(params.rho_spatial, tmpy(:)) );
            
        end;

    end;
end;
        
% segmentation smoothness
enSeg = 0;

vert = im2col((reshape(1:H*W,H,W)),[2 1])';
hor  = im2col((reshape(1:H*W,H,W)),[1 2])';
for t=1:params.T    
    
    % compute color weight
    wv = compute_color_weight(data.labImages{t}, vert, params.T2_lab, params.sigma_lab);
    wh = compute_color_weight(data.labImages{t}, hor,  params.T2_lab, params.sigma_lab);

    tmp = layer_seg(:,:,t);
    
    tmpx = tmp(hor(:,1)) ~= tmp(hor(:,2));
    tmpy = tmp(vert(:,1)) ~= tmp(vert(:,2));
    
    enSeg = enSeg + sum(tmpx(:).*wh(:)) + sum(tmpy(:).*wv(:));
    
end;
    

% data term
enData = 0;
for t=1:params.T    
    uv = composite_final_flow_seg(layer_uv{t}, layer_seg(:,:,t));        

    It = partial_deriv(data.images{t}, uv,...
             params.interpolation_method, params.deriv_filter);               
        
    [neighbors OOB] = compute_temporal_neigbhors(uv);
    
    seg = layer_seg(:,:,t);
    % only works for 2-frame case
    tmpSeg  = layer_seg(:,:,3-t);
    warpSeg = tmpSeg(neighbors);
    
    occ = seg > warpSeg;
    forb = seg< warpSeg;
    
    It = reshape(evaluate(params.rho_data, It(:)), [H W]);
    
    It(occ) = params.lambdaOcc;
    It(forb)= params.lambdaForbid;
    It(OOB) = params.lambdaOcc;
        
    enData = enData+ sum(It(:));
end;



en = enFlow*params.lambdaFlow + enSeg*params.lambdaSeg + enData;





